import java.awt.Color;



class PlotData extends Object {

    public int       id;
    public Vector3D  vec;
    public Vector3D  viewvec;
    public Color     color;
    public float     size;


    PlotData (int dataid, Color cubecolor, float cubesize,
                 float x, float y, float z) {

        id      = dataid;
        vec     = new Vector3D (x, y, z);
        viewvec = null;
        color   = cubecolor;
        size    = cubesize;
    }




    PlotData (PlotData data) {

        id      = data.id;
        vec     = new Vector3D (data.vec.x, data.vec.y, data.vec.z);
        viewvec = null;
        color   = data.color;
        size    = data.size;
    }


}



