public class LOGOBDThread extends Thread
{
    LOGOBDframe obd_frame = null;
    TunerLog tuner_handle = null;
    serialio sio = null;
    String title = null;
    int cable_type = 0;
    javax.swing.JButton interface_button = null;
    LOGOBDThread1 log_handle = null;
    error_dialog error_diag = null;
    
    public void run()
    {
        try
        {
            if (sio == null)
                sio = new serialio();
            if (sio.getver() != 6)
            {
                error_rtn("Wrong or missing DLL - SNJ2TNTCLIB.DLL!  See www.tunerstein.com/dll.htm for help.");
                return;
            }
        }
        catch (UnsatisfiedLinkError ioe)
        {
                error_rtn("Wrong or missing DLL - SNJ2TNTCLIB.DLL!  See www.tunerstein.com/dll.htm for help.");
                return;
        }
            
        if (obd_frame == null)    
            obd_frame = new LOGOBDframe();
            
        if (cable_type >= 5)
        {
            obd_frame.cable_type.select(cable_type);
            obd_frame.cable_type.setEnabled(false);
            obd_frame.obd_link = false;
        }
        else
            obd_frame.obd_link = true;
        obd_frame.set_controls();
        obd_frame.setTitle(title);
        obd_frame.setVisible(true);
        obd_frame.serial_handle = sio;
        obd_frame.thread_handle = this;
        obd_frame.tuner_handle = tuner_handle;
        tuner_handle.obd_frame = obd_frame;
        sio.tuner_handle = tuner_handle;
        obd_frame.interface_button = interface_button;
        obd_frame.chartcontrol_frame = tuner_handle.chartcontrol_frame;
        obd_frame.chartcontrol_frame.pf = obd_frame;
        if (tuner_handle.reg_flag != 1)
        {
          obd_frame.choose_port.setEnabled(false);
          obd_frame.choose_port.select(5);
          obd_frame.choosePort_ItemStateChanged((java.awt.event.ItemEvent) null);        
        }
        
        // open com port
        
        //   open log file
        // log data (loop, include yield() function?)
        //   close log file
        // close com port
    }
	void error_rtn(String em)
	{
		try {
			// record_dialog Create and show as non-modal
			if (error_diag == null)
			error_diag = new error_dialog();
			error_diag.error_field.setText(em);
			error_diag.setVisible(true);
		} catch (java.lang.Exception e) {
		}
	}


}