import java.lang.System;
import java.awt.*;

public class serialio
{
    static int obd_stop_flag = 1;
    static int drb_stop_flag = 1;
    static int pms_stop_flag = 1;
    TunerLog tuner_handle = null;
    java.awt.TextField status = null;
    datavalues datavalue_handle = null;
    
    public native int getPMS(int i4, int i5, int int1, int int2);
    static
    {
        System.loadLibrary("tntclib");
    }
    public native int getver();
    static
    {
        System.loadLibrary("tntclib");
    }
    public native int RaiseLines(int i4);
    static
    {
        System.loadLibrary("tntclib");
    }
    public native int SioReset(int i4, int i1, int i2, int i3); 
    static
    {
        System.loadLibrary("tntclib");
    }
    public native int SioDone(int i1);
    static
    {
        System.loadLibrary("tntclib");
    }
    public native int logdata(int i1, int i2, int i3, int i4[], int i5, int i6);
    static
    {
        System.loadLibrary("tntclib");
    }
    
    public native int dodiag(int port, int diag);
    static
    {
        System.loadLibrary("tntclib");
    }    
    
    public native int getDTC(int i1, int p1);
    static
    {
        System.loadLibrary("tntclib");
    }
    
    public native void clearDTC(int a);
    static
    {
        System.loadLibrary("tntclib");
    }
    
    private void update_status(int a)
    {
        status.setText(Integer.toString(a));
        return;
    }
    private void update_pause(int a)
    {
        if (a == 1 || a == 0)
        {
          tuner_handle.pause_button.setText("Pause");
        }
        else
        {
          tuner_handle.pause_button.setText("Resume");
        }
        return;
    }
    
    private void plot_point(int cable_type, int comport, int hob, int lob, int parm_id)
    {
        float fv = 0F;
        
        int     pv = 0;
        int     fi = 0;
        
        // is charting enabled?
        
        // System.out.println(parm_id);
        
//        if (!tuner_handle.logcharts.isSelected())
//            return;
            
        // determine if we are using OBD, DRB, or PMS
        
        // build base value
        
//        System.out.println(cable_type + " " + parm_id);
        
        if (cable_type < 0)
        {
            if (tuner_handle.datavalue_handle != null)
              datavalue_handle = tuner_handle.datavalue_handle;
            else
            {
		        try 
		        {
			        if (datavalue_handle == null)
			            datavalue_handle = new datavalues();
			        datavalue_handle.setVisible(true);
			        tuner_handle.datavalue_handle = datavalue_handle;
		        } 
		        catch (java.lang.Exception e) 
		        {
		        }
		    }
		    datavalue_handle.define_fields(parm_id, cable_type);
        }
        else
          datavalue_handle.table_index = 0;
        datavalue_handle.setVisible(true);
        
        if (!tuner_handle.logcharts.isSelected())
            return;
        if (cable_type == 4) // DRB
        {
            pv = 0;
            fi = 0;
            fv = (float)(lob);
            
            if (parm_id == 0) // timing
            {
                fv = fv - 10;
                fi = 2;
            }
            
            if (parm_id == 3) // o2v
            {
                fv = fv * .02F;
                fv = fv * 100;
                fi = 5;
            }
            
            if (parm_id == 1) // coolant
            {
                fv = fv * 0F;
                fi = 4;
            }
            
            if (parm_id == 12) // low trim
            {
                fv = fv * 1.27F;
                fi = 10;
            }
            
            if (parm_id == 13) // low trim
            {
                fv = fv * 1.27F;
                fi = 11;
            }
            
            if (parm_id == 7) // tps
            {
                fv = fv / 2.55F;
                fv = fv * 100;
                fi = 7;
            }
            
            if (parm_id == 18) // air flow
            {
                fv = fv * 1F;
                fi = 8;
            }
            
            if (parm_id == 9) // rpm
            {
                fv = fv * 31.37F;
                fi = 1;
            }
            
            if (parm_id == 17) // knock
            {
                fv = fv * .2F;
                fi = 9;
            }
            
            if (parm_id == 10) // pulse width
            {
                fv = fv * .256F;
                fi = 3;
            }
            
            if (parm_id == 11) // air temp
            {
                fv = fv * 1;
                fi = 6;
            }
            
            if (parm_id == 48)
            {
                fv = fv * 1.27F;
                fi = 14;
            }
            
            if (fi == 0)
              return;
        }
        
        if (cable_type < 4) // obd
        {
            pv = 0;
            fi = 0;
            fv = (float)(hob * 256) + (float)(lob);
        
            if (parm_id == 0)   // timing
            {
                fv = (fv - 128F) * .5F;
                fi = 2;
            }
            if (parm_id == 1)   // ect
            {
                fv = ((fv - 40f) * 1.8F) + 32F;
                fi = 4;
            }
            if (parm_id == 3)   // o2 voltage
            {
                fv = fv *.005F;
                fv = fv * 100;
                fi = 5;
            }
            if (parm_id == 7)   // TPS
            {
                fv = (fv / 255F) * 100F;
                fv = fv * 100;
                fi = 7;
            }
            if (parm_id == 11)  // air temp
            {
                fv = ((fv - 40f) * 1.8F) + 32F;
                fi = 6;
            }
            if (parm_id == 12)  // short trim
            {
                fv = ((fv / 128F) * 100F) - 100F;
                fi = 10;
            }
            if (parm_id == 13)  // long trim
            {
                fv = ((fv / 128F) * 100F) - 100F;
                fi = 11;
            }
            if (parm_id == 9)   // rpm
            {
                fv = fv / 4F;
                fi = 1;
            }
            if (parm_id == 18) // air flow hz
            {
                fv = fv / 100F;
                fi = 8;
            }
            
            if (fi == 0)
                return;
        }
        
        if (cable_type != 1 && cable_type != 4)
          return;

        if (tuner_handle.obd_frame.chart_frames[fi] != null)
        {
//            System.out.println(cable_type + " " + tuner_handle.obd_frame.chart_frames[fi].chart_high);
            if (cable_type < 0)
                tuner_handle.obd_frame.chart_frames[fi].clear_chart();
            if (tuner_handle.obd_frame.chart_frames[fi].chart_high == -1)
                tuner_handle.obd_frame.chart_frames[fi].setrange(fi);
        }
            
        if (tuner_handle.obd_frame.chart_frames[fi].test_delta == 0)
        {
            tuner_handle.obd_frame.chart_frames[fi].setrange(fi);
            tuner_handle.obd_frame.chart_frames[fi].test_delta = 1;
        }
            
        pv = (int)(fv * 100F);

        //System.out.println(comport + " " + tuner_handle.obd_frame.chart_frames[fi].chart_high + " " + tuner_handle.obd_frame.chart_frames[fi].test_delta);
        if (comport == 4)
        {
            if (tuner_handle.obd_frame.chart_frames[fi].test_point > tuner_handle.obd_frame.chart_frames[fi].chart_high)
                tuner_handle.obd_frame.chart_frames[fi].test_delta = -1;
            else
                if (tuner_handle.obd_frame.chart_frames[fi].test_point < tuner_handle.obd_frame.chart_frames[fi].chart_low)
                    tuner_handle.obd_frame.chart_frames[fi].test_delta = 1;
            pv = tuner_handle.obd_frame.chart_frames[fi].test_point * 100;
        }
                
        if (tuner_handle.obd_frame.chart_frames[fi].datavalue_handle == null)
          tuner_handle.obd_frame.chart_frames[fi].datavalue_handle = datavalue_handle;
          
        //System.out.println("pv = " + pv + " " + fv + " " + comport);
        tuner_handle.obd_frame.chart_frames[fi].plot_point(pv);

		if (tuner_handle.obd_frame.chart_frames[fi] == null)
		  datavalue_handle.set_value(parm_id, (float)pv / 100F);
          
        if (comport == 4)
            tuner_handle.obd_frame.chart_frames[fi].test_point += tuner_handle.obd_frame.chart_frames[fi].test_delta;
        return;
    }
}