import java.awt.*;



class InfoLine extends Canvas {

    private static Font font = new Font ("TimesRoman", Font.BOLD, 12);
    private static InfoLine inst = null;
    
    public InfoLine () {
        inst = this;
        resize (400, 20);
    }
    
    
    public static void setText (String text) {
        Graphics graph = inst.getGraphics ();
        graph.setColor (Color.lightGray);
        graph.fillRect (0, 0, inst.size().width, inst.size().height);
        graph.setFont (font);
        
        graph.setColor (Color.white);
        graph.drawString (text, 6, 15);
        graph.setColor (Color.darkGray);
        graph.drawString (text, 5, 14);
    }
    
    
    public static void clearText () {
        Graphics graph = inst.getGraphics ();
        graph.setColor (Color.lightGray);
        graph.fillRect (0, 0, inst.size().width, inst.size().height);
    }
    
    
    public void paint (Graphics graph) {
        graph.setColor (Color.lightGray);
        graph.fillRect (0, 0, size().width, size().height);
    }
}

    
       
