/*
	A basic extension of the java.awt.Frame class
*/
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.lang.Math.*;
import javax.swing.JTextPane;
import javax.swing.JButton;
import javax.swing.JSlider;
import com.symantec.itools.javax.swing.borders.BevelBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import com.symantec.itools.javax.swing.icons.ImageIcon;
import symantec.itools.awt.Wizard;
import com.symantec.itools.javax.swing.JChart;
import java.util.StringTokenizer;
import symantec.itools.awt.InvisibleButton;

public class  PLAYframe extends javax.swing.JFrame
{
    AFCframe1 afc_frame = null;
    AFRframe afr_frame = null;
    csv_dialog csv_diag = null;
    PNSTEINdialog PNSTEINdialog1;
    int tframe = 0;
    AFCframe2 afc2_frame = null;
    ITCframe1 itc_frame = null;
    PMSframe  pms_frame = null;
    CHART2Dframe c2d_frame = null;
    CHART3Dframe c3d_frame = null;
    chartcontrolp chartcontrol_frame = null;
    
    int reg_flag = 0;
    int tpsrange_value = 95;
    int rpmrange_value = 8000;
    int max_charts = 22;

	OutputStream fileOut = null;
	BufferedOutputStream bufOut;
	PrintStream logout;

	StringBuffer logrecord = new StringBuffer(500);
    boolean chart_2d = false;
    boolean chart_3d = false;
    boolean csv_file = false;
    chartthread chart_frames[] = new chartthread[30];

    int fuel_base = 1;

    error_dialog error_diag =  null;

    float pulse_ratio = 0F;

    boolean    single_click = false;
    JTextField    cell_locked = null;
    String theFile;
    String tFile;// log file name
    String theFileDir;                          // log file dir name
    int    logfiletype = 0;                     // 1 pms, 2 tmo, 0 undefined
    long    log_records;                         // number of records in pms log file
    int    log_record_length;                   // length of log record (in bytes)
    long    current_log_record;                  // current log record
	int    drb_parm_count;                      // number of logged tmo parms
    int    drb_type[] = new int[100];            // list of logged tmo data fields
    int    adjust_fuel_pcnt = 0;
    float  adjust_fuel_pw = 0F;
    float  adjust_fuel_o2 = 0F;
    long   first_record;                        // file offset to record 1 in log file

	File f1 = null;                             // work file
	RandomAccessFile rf1;                       // work file

	File f1x = null;                            // work file
	RandomAccessFile rf1x;                      // work file

	int   x_2d = 0;
	int   y_2d = 0;

	int   pms_ecu_rpms;                             // rpms
	byte  pms_ecu_timing;                           // timing
	byte  pms_timing;                           // timing
	float pms_ecu_pulsewidth;                       // injector pulse width
	float pms_pulsewidth;                       // injector pulse width
	int  pms_watertemp;                        // pms water temp
	int   pms_hz;
	float pms_o2voltage;                        // pms o2 voltage
	int   pms_airtemp;                          // pms intake air temp
	byte  pms_tps;                              // pms tps %
	float pms_pressure;                         // pms manifold pressure
	byte  pms_fueladdition;                     // pms fuel delta
	byte  pms_timingaddition;                   // pms timing delta
	byte  pms_acc;                              // pms accessory input/output flags

	int   drb_rpms;                             // rpms
	byte  drb_timing;                           // timing
	float drb_pulsewidth;                       // injector pulse width
	int   drb_watertemp;                        // pms water temp
	float drb_o2voltage;                        // pms o2 voltage
	int   drb_airtemp;                          // pms intake air temp
	byte  drb_tps;                              // pms tps %
	float drb_pressure;                         // pms manifold pressure
	byte  drb_knock;
    int   drb_records;                          // number of records in pms file
    int   drb_mph;
    int   drb_map;
    int   drb_ticks;
    int   drb_s2;
    int   drb_s1;
    int   drb_l1;
    int   drb_l2;
    int   drb_mtrim;
    int   drb_load;
    float drb_afhz;
    float drb_o2;
    int   drb_o2trim;
    float drb_data_fields[] = new float[100];  // frame data values (indexed by field type)
    float o2_target = 0;
    int   adjust_fuel_limit = 0;
    int   count_3d = 0;

    float peak_values[][] = new float[2][5];
    float log_analysis[][] = new float[8][20];
    javax.swing.JTextField display_cells[][]= new javax.swing.JTextField[7][20];

    boolean first_time = true;
    String rtd_line;
    String rtd_line1;
    
    String player_version = "Player 5.0a";

	public PLAYframe()
	{
	    int temp_index; 
	    
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Log File Playback");
		getContentPane().setLayout(null);
		getContentPane().setBackground(new java.awt.Color(204,204,204));
		setSize(557,353);
		setVisible(false);
		JTextPane1.setText("This panel is used to play back log files.");
		JTextPane1.setAlignmentY(1.0F);
		JTextPane1.setAlignmentX(1.0F);
		JTextPane1.setDisabledTextColor(java.awt.Color.lightGray);
		JTextPane1.setEditable(false);
		getContentPane().add(JTextPane1);
		JTextPane1.setBackground(new java.awt.Color(204,204,204));
		JTextPane1.setBounds(126,0,304,28);
		Data_Display.setEditable(false);
		getContentPane().add(Data_Display);
		Data_Display.setBackground(new java.awt.Color(204,204,204));
		Data_Display.setBounds(206,40,240,92);
		open_file.setText("Open file");
		open_file.setActionCommand("Open file");
		open_file.setBorder(bevelBorder1);
		open_file.setToolTipText("Open a log file");
		getContentPane().add(open_file);
		open_file.setBackground(new java.awt.Color(204,204,204));
		open_file.setBounds(110,40,80,24);
		close_file.setText("Close file");
		close_file.setActionCommand("Close file");
		close_file.setBorder(bevelBorder1);
		close_file.setToolTipText("Close log file");
		close_file.setEnabled(false);
		getContentPane().add(close_file);
		close_file.setBackground(new java.awt.Color(204,204,204));
		close_file.setBounds(110,88,80,24);
		single_backward.setText("<");
		single_backward.setActionCommand("<");
		single_backward.setBorder(bevelBorder1);
		single_backward.setToolTipText("Show previous log entry");
		single_backward.setEnabled(false);
		getContentPane().add(single_backward);
		single_backward.setBackground(new java.awt.Color(204,204,204));
		single_backward.setBounds(206,136,24,24);
		single_forward.setText(">");
		single_forward.setActionCommand(">");
		single_forward.setBorder(bevelBorder1);
		single_forward.setToolTipText("Show next log entry");
		single_forward.setEnabled(false);
		getContentPane().add(single_forward);
		single_forward.setBackground(new java.awt.Color(204,204,204));
		single_forward.setBounds(326,136,24,24);
		rewind_button.setText("<<");
		rewind_button.setActionCommand("<<");
		rewind_button.setBorder(bevelBorder1);
		rewind_button.setToolTipText("Rewind to first record");
		rewind_button.setEnabled(false);
		getContentPane().add(rewind_button);
		rewind_button.setBackground(new java.awt.Color(204,204,204));
		rewind_button.setBounds(350,136,24,24);
		play_button.setText(">>");
		play_button.setActionCommand(">>");
		play_button.setBorder(bevelBorder1);
		play_button.setToolTipText("Animated play");
		play_button.setEnabled(false);
		getContentPane().add(play_button);
		play_button.setBackground(new java.awt.Color(204,204,204));
		play_button.setBounds(374,136,24,24);
		chart_button.setText("2D");
		chart_button.setActionCommand("Chart");
		chart_button.setBorder(bevelBorder1);
		chart_button.setToolTipText("Chart log file data");
		chart_button.setEnabled(false);
		getContentPane().add(chart_button);
		chart_button.setBackground(new java.awt.Color(204,204,204));
		chart_button.setBounds(398,136,26,24);
		file_slider.setValue(0);
		file_slider.setMaximum(1);
		file_slider.setBorder(bevelBorder1);
		file_slider.setValueIsAdjusting(true);
		file_slider.setToolTipText("Slide through the log entries");
		file_slider.setEnabled(false);
		getContentPane().add(file_slider);
		file_slider.setBackground(new java.awt.Color(204,204,204));
		file_slider.setBounds(230,136,96,24);
		//$$ bevelBorder1.move(0,301);
		open_log_file.setMode(FileDialog.LOAD);
		open_log_file.setTitle("Open");
		//$$ open_log_file.move(24,301);
		JLabel1.setText("Peak Values at");
		getContentPane().add(JLabel1);
		JLabel1.setBackground(new java.awt.Color(204,204,204));
		JLabel1.setForeground(java.awt.Color.black);
		JLabel1.setBounds(24,168,86,24);
		max_rpms.setText("RPMS");
		max_rpms.setActionCommand("RPMS");
		max_rpms.setBorder(bevelBorder1);
		max_rpms.setToolTipText("Show max rpm entry");
		max_rpms.setEnabled(false);
		getContentPane().add(max_rpms);
		max_rpms.setBackground(new java.awt.Color(204,204,204));
		max_rpms.setBounds(122,192,56,24);
		max_o2_voltage.setText("o2\'s");
		max_o2_voltage.setActionCommand("o2\'s");
		max_o2_voltage.setBorder(bevelBorder1);
		max_o2_voltage.setToolTipText("Show max O2 voltage");
		max_o2_voltage.setEnabled(false);
		getContentPane().add(max_o2_voltage);
		max_o2_voltage.setBackground(new java.awt.Color(204,204,204));
		max_o2_voltage.setBounds(186,192,56,24);
		max_timing.setText("Timing");
		max_timing.setActionCommand("Timing");
		max_timing.setBorder(bevelBorder1);
		max_timing.setToolTipText("Show max timing advance entry");
		max_timing.setEnabled(false);
		getContentPane().add(max_timing);
		max_timing.setBackground(new java.awt.Color(204,204,204));
		max_timing.setBounds(250,192,56,24);
		max_pulse_width.setText("P/W");
		max_pulse_width.setActionCommand("P/W");
		max_pulse_width.setBorder(bevelBorder1);
		max_pulse_width.setToolTipText("Display max pulse width entry");
		max_pulse_width.setEnabled(false);
		getContentPane().add(max_pulse_width);
		max_pulse_width.setBackground(new java.awt.Color(204,204,204));
		max_pulse_width.setFont(new Font("Dialog", Font.BOLD, 12));
		max_pulse_width.setBounds(314,192,56,24);
		max_knock.setText("Knock");
		max_knock.setActionCommand("Knock");
		max_knock.setBorder(bevelBorder1);
		max_knock.setToolTipText("Show max \'knock count\' entry");
		max_knock.setEnabled(false);
		getContentPane().add(max_knock);
		max_knock.setBackground(new java.awt.Color(204,204,204));
		max_knock.setBounds(378,192,56,24);
		animate_control.setText("Animate");
		animate_control.setActionCommand("Animate");
		animate_control.setBorder(bevelBorder1);
		animate_control.setToolTipText("Animated playback using controller panels");
		getContentPane().add(animate_control);
		animate_control.setBackground(new java.awt.Color(204,204,204));
		animate_control.setBounds(472,112,80,24);
		o2_slider.setBorder(bevelBorder1);
		o2_slider.setToolTipText("Drag to adjust o2 voltage");
		o2_slider.setOrientation(javax.swing.JSlider.VERTICAL);
		getContentPane().add(o2_slider);
		o2_slider.setBackground(new java.awt.Color(204,204,204));
		o2_slider.setForeground(java.awt.Color.black);
		o2_slider.setBounds(448,40,20,92);
		itc_animate.setText("Timing");
		itc_animate.setActionCommand("Timing");
		itc_animate.setToolTipText("Display the ignition timing controller map");
		getContentPane().add(itc_animate);
		itc_animate.setBackground(new java.awt.Color(204,204,204));
		itc_animate.setBounds(472,40,80,24);
		itc_animate.setVisible(false);
		afc_animate.setText("AFC (old)");
		afc_animate.setActionCommand("AFC (old)");
		afc_animate.setToolTipText("Display fuel controller map");
		getContentPane().add(afc_animate);
		afc_animate.setBackground(new java.awt.Color(204,204,204));
		afc_animate.setBounds(472,64,80,24);
		afc_animate.setVisible(false);
		afc2_animate.setText("AFC (new)");
		afc2_animate.setActionCommand("AFC (new)");
		afc2_animate.setToolTipText("Display fuel controller map");
		getContentPane().add(afc2_animate);
		afc2_animate.setBackground(new java.awt.Color(204,204,204));
		afc2_animate.setBounds(472,88,80,24);
		afc2_animate.setVisible(false);
		advanced_fuel_calc.setText("Calc mthd");
		advanced_fuel_calc.setActionCommand("Calc mthd");
		advanced_fuel_calc.setBorder(bevelBorder1);
		advanced_fuel_calc.setToolTipText("Selects cumulative fuel calculations (not normally used)");
		getContentPane().add(advanced_fuel_calc);
		advanced_fuel_calc.setBackground(new java.awt.Color(204,204,204));
		advanced_fuel_calc.setBounds(472,8,80,24);
		advanced_fuel_calc.setVisible(false);
		show_low_values.setText("Low vals");
		show_low_values.setActionCommand("Low vals");
		show_low_values.setBorder(bevelBorder1);
		show_low_values.setToolTipText("Show LOW o2 & timing values");
		getContentPane().add(show_low_values);
		show_low_values.setBackground(new java.awt.Color(204,204,204));
		show_low_values.setBounds(472,168,80,24);
		show_low_values.setVisible(false);
		reset_button.setText("Reset");
		reset_button.setActionCommand("Reset");
		reset_button.setBorder(bevelBorder1);
		reset_button.setToolTipText("Reset simulator & re-calculate");
		reset_button.setEnabled(false);
		getContentPane().add(reset_button);
		reset_button.setBackground(new java.awt.Color(204,204,204));
		reset_button.setBounds(56,192,56,24);
		reset_button.setVisible(false);
		chart_all.setText("Chart all");
		chart_all.setActionCommand("Chart all");
		chart_all.setBorder(bevelBorder1);
		chart_all.setToolTipText("Select to chart all instead of just 100% tps");
		getContentPane().add(chart_all);
		chart_all.setBackground(new java.awt.Color(204,204,204));
		chart_all.setBounds(472,144,80,24);
		chart_all.setVisible(false);
		chart3d.setText("3D");
		chart3d.setActionCommand("3D");
		chart3d.setBorder(bevelBorder1);
		chart3d.setToolTipText("Chart log file data in 3D");
		chart3d.setEnabled(false);
		getContentPane().add(chart3d);
		chart3d.setBackground(new java.awt.Color(204,204,204));
		chart3d.setBounds(424,136,26,24);
		getContentPane().add(invisibleButton1);
		invisibleButton1.setBackground(new java.awt.Color(204,204,204));
		invisibleButton1.setBounds(132,96,20,24);
		JLabel2.setText(" percent TPS (and above) or above");
		getContentPane().add(JLabel2);
		JLabel2.setBackground(new java.awt.Color(204,204,204));
		JLabel2.setForeground(java.awt.Color.black);
		JLabel2.setBounds(156,168,204,24);
		tpsrange.setText("95");
		tpsrange.setToolTipText("Set minimum TPS limit for analyzer operations");
		getContentPane().add(tpsrange);
		tpsrange.setBackground(java.awt.Color.white);
		tpsrange.setForeground(java.awt.Color.black);
		tpsrange.setFont(new Font("Dialog", Font.BOLD, 12));
		tpsrange.setBounds(120,168,32,24);
		pnsteinbutton.setText("Palm\'n\'Stein");
		pnsteinbutton.setActionCommand("Open file");
		pnsteinbutton.setBorder(bevelBorder1);
		pnsteinbutton.setToolTipText("Collect data from Palm\'n\'Stein");
		getContentPane().add(pnsteinbutton);
		pnsteinbutton.setBackground(java.awt.Color.green);
		pnsteinbutton.setBounds(24,40,80,24);
		saveobdfile.setMode(FileDialog.SAVE);
		saveobdfile.setTitle("Save Log File");
		//$$ saveobdfile.move(48,312);
		savedrbfile.setMode(FileDialog.SAVE);
		savedrbfile.setTitle("Save Log File");
		//$$ savedrbfile.move(72,312);
		rpmrange.setText("4000");
		rpmrange.setToolTipText("Set minimum RPM limit for analyzer operations");
		getContentPane().add(rpmrange);
		rpmrange.setBackground(java.awt.Color.white);
		rpmrange.setForeground(java.awt.Color.black);
		rpmrange.setFont(new Font("Dialog", Font.BOLD, 12));
		rpmrange.setBounds(360,168,32,24);
		JLabel3.setText("RPMS");
		getContentPane().add(JLabel3);
		JLabel3.setBackground(new java.awt.Color(204,204,204));
		JLabel3.setForeground(java.awt.Color.black);
		JLabel3.setBounds(396,168,36,24);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		open_file.addMouseListener(aSymMouse);
		close_file.addMouseListener(aSymMouse);
		single_backward.addMouseListener(aSymMouse);
		single_forward.addMouseListener(aSymMouse);
		rewind_button.addMouseListener(aSymMouse);
		SymPropertyChange lSymPropertyChange = new SymPropertyChange();
		file_slider.addPropertyChangeListener(lSymPropertyChange);
		SymChange lSymChange = new SymChange();
		file_slider.addChangeListener(lSymChange);
		play_button.addMouseListener(aSymMouse);
		max_rpms.addMouseListener(aSymMouse);
		max_o2_voltage.addMouseListener(aSymMouse);
		max_timing.addMouseListener(aSymMouse);
		max_pulse_width.addMouseListener(aSymMouse);
		max_knock.addMouseListener(aSymMouse);
		add_controls();
		SymFocus aSymFocus = new SymFocus();

		int row = 1;
		do
		{
		    int column = 1;
		    do
		    {
		        display_cells[row][column].addMouseListener(aSymMouse);
		        display_cells[row][column].addFocusListener(aSymFocus);
		        ++ column;
		    }
		    while(column <= 16);
		    ++ row;
		}
		while (row <= 4);
	    for (row=1;row<=max_charts;row++)
		{
		    chart_frames[row] = new chartthread();
		    chart_frames[row].start();
	    }
		SymItem lSymItem = new SymItem();
		animate_control.addItemListener(lSymItem);
		o2_slider.addChangeListener(lSymChange);
		o2_slider.addMouseListener(aSymMouse);
		animate_control.addMouseListener(aSymMouse);
		itc_animate.addMouseListener(aSymMouse);
		afc_animate.addMouseListener(aSymMouse);
		afc2_animate.addMouseListener(aSymMouse);
		reset_button.addMouseListener(aSymMouse);
		chart_button.addMouseListener(aSymMouse);
		chart3d.addMouseListener(aSymMouse);
		file_slider.addMouseListener(aSymMouse);
		invisibleButton1.addMouseListener(aSymMouse);
		SymText lSymText = new SymText();
		SymAction lSymAction = new SymAction();
		tpsrange.addActionListener(lSymAction);
		SymKey aSymKey = new SymKey();
		tpsrange.addKeyListener(aSymKey);
		pnsteinbutton.addMouseListener(aSymMouse);
		Data_Display.addMouseListener(aSymMouse);
		tpsrange.addFocusListener(aSymFocus);
		rpmrange.addFocusListener(aSymFocus);
		//}}
		

	}

	public PLAYframe(String title)
	{
//		this(afc_frame, afc2_frame, itc_frame, pms_frame);
		setTitle(title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			//setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
//		(new PLAYframe()).setVisible(true);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JTextPane JTextPane1 = new javax.swing.JTextPane();
	java.awt.TextArea Data_Display = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
	javax.swing.JButton open_file = new javax.swing.JButton();
	javax.swing.JButton close_file = new javax.swing.JButton();
	javax.swing.JButton single_backward = new javax.swing.JButton();
	javax.swing.JButton single_forward = new javax.swing.JButton();
	javax.swing.JButton rewind_button = new javax.swing.JButton();
	javax.swing.JButton play_button = new javax.swing.JButton();
	javax.swing.JButton chart_button = new javax.swing.JButton();
	javax.swing.JSlider file_slider = new javax.swing.JSlider();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	java.awt.FileDialog open_log_file = new java.awt.FileDialog(this);
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JButton max_rpms = new javax.swing.JButton();
	javax.swing.JButton max_o2_voltage = new javax.swing.JButton();
	javax.swing.JButton max_timing = new javax.swing.JButton();
	javax.swing.JButton max_pulse_width = new javax.swing.JButton();
	javax.swing.JButton max_knock = new javax.swing.JButton();
	javax.swing.JCheckBox animate_control = new javax.swing.JCheckBox();
	javax.swing.JSlider o2_slider = new javax.swing.JSlider();
	javax.swing.JCheckBox itc_animate = new javax.swing.JCheckBox();
	javax.swing.JCheckBox afc_animate = new javax.swing.JCheckBox();
	javax.swing.JCheckBox afc2_animate = new javax.swing.JCheckBox();
	javax.swing.JCheckBox advanced_fuel_calc = new javax.swing.JCheckBox();
	javax.swing.JCheckBox show_low_values = new javax.swing.JCheckBox();
	javax.swing.JButton reset_button = new javax.swing.JButton();
	javax.swing.JCheckBox chart_all = new javax.swing.JCheckBox();
	javax.swing.JButton chart3d = new javax.swing.JButton();
	symantec.itools.awt.InvisibleButton invisibleButton1 = new symantec.itools.awt.InvisibleButton();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField tpsrange = new javax.swing.JTextField();
	javax.swing.JButton pnsteinbutton = new javax.swing.JButton();
	java.awt.FileDialog saveobdfile = new java.awt.FileDialog(this);
	java.awt.FileDialog savedrbfile = new java.awt.FileDialog(this);
	javax.swing.JTextField rpmrange = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowOpened(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PLAYframe.this)
				PLAYframe_windowOpened(event);
		}

		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PLAYframe.this)
				PLAYframe_WindowClosing(event);
		}
	}

	void PLAYframe_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
		if (itc_frame != null)
		    itc_frame.setVisible(false);
		if (afc_frame != null)
		    afc_frame.setVisible(false);
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == o2_slider)
				o2Slider_mouseReleased(event);
			else if (object == file_slider)
				fileSlider_mouseReleased(event);
		}

		public void mouseEntered(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (cell_locked != null)
			    return;
			if (object == max_knock)
				maxKnock_mouseEntered(event);
            else
                show_values(object);
		}

		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == open_file)
				openFile_mouseClicked(event);
			else if (object == close_file)
				closeFile_mouseClicked(event);
			else if (object == single_backward)
				singleBackward_mouseClicked(event);
			else if (object == single_forward)
				singleForward_mouseClicked(event);
			else if (object == rewind_button)
				rewindButton_mouseClicked(event);
			else if (object == play_button)
				playButton_mouseClicked(event);
			else if (object == max_rpms)
				maxRpms_mouseClicked(event);
			else if (object == max_o2_voltage)
				maxO2Voltage_mouseClicked(event);
			else if (object == max_timing)
				maxTiming_mouseClicked(event);
			else if (object == max_pulse_width)
				maxPulseWidth_mouseClicked(event);
			else if (object == max_knock)
				maxKnock_mouseClicked(event);
			else if (object == animate_control)
				animateControl_mouseClicked(event);
			else if (object == itc_animate)
				itcAnimate_mouseClicked(event);
			else if (object == afc_animate)
				afcAnimate_mouseClicked(event);
			else if (object == afc2_animate)
				afc2Animate_mouseClicked(event);
			else if (object == reset_button)
				resetButton_mouseClicked(event);
			else if (object == chart_button)
				chartButton_mouseClicked(event);
			else if (object == chart3d)
				chart3d_mouseClicked(event);
			else if (object == invisibleButton1)
				invisibleButton1_mouseClicked(event);
			else if (object == pnsteinbutton)
				pnsteinbutton_mouseClicked(event);
			else if (cell_locked == null)
			{
		        int row = 1;
		        do
		        {
		            int column = 1;
		            do
		            {
		                if (display_cells[row][column] == object)
		                {
		                    cell_locked = display_cells[row][column];
		                    Data_Display.setForeground(java.awt.Color.red);
		                    display_cells[row][column].selectAll();
		                    o2_slider.setEnabled(true);
		                    return;
		                }
		                ++ column;
		            }
		            while(column <= 16);
		            ++ row;
		        }
		        while (row <= 4);
			}
		}
	}

	void openFile_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.

		open_file_mouseClicked_Interaction1(event);
	}

	void open_file_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		try {
			// open_log_file Show the FileDialog
			open_log_file.setVisible(true);
		} catch (java.lang.Exception e) {
		}
    	theFile = open_log_file.getFile();
    	theFileDir = open_log_file.getDirectory();
	    if ( (theFile == null) || (theFile.equals("")))
	        return;
	    else
        {    	
    	    recall_cfg1();
    	    reset_charts();    
            plot_data();
        }

	}
	
	void recall_cfg1()
	{
		int int1 = 0;
		csv_file = false;
		do
		{
		    peak_values[0][int1] = 0;
		    peak_values[1][int1] = 0;
		    int1 ++;
		}
		while(int1 <= 4);
		int1 = 0;
		do
		{
		    log_analysis[0][int1] = 0;
		    log_analysis[1][int1] = 0;
		    log_analysis[2][int1] = 0;
		    log_analysis[3][int1] = 0;
		    log_analysis[4][int1] = 0;
		    log_analysis[5][int1] = 0;
		    log_analysis[6][int1] = 0;
		    ++ int1;
		}
		while (int1 < 20);
	    if ( (theFile == null) || (theFile.equals("")))
	    {
	        //no selected file so abort
	        return;
	    }
	    try
	    {
	        File f=new File(theFileDir, theFile);
	        if(!f.exists() || !f.isFile())
	        {   //file not there, abort
	            return;
	        }
	        //setTitle(theFile);
	        tFile = theFile.toLowerCase();
	        logfiletype = 0;
	        if (tFile.endsWith(".tlg") || tFile.endsWith(".db1") || tFile.endsWith(".db2"))
	        {
	            logfiletype = 2;
	            if (!tFile.endsWith(".tlg"))
	                csv_file = true;
	        }
            if (tFile.endsWith(".dab"))
	        {
	            logfiletype = 1;
	        }
	        if (logfiletype == 0)
	        {
				logfiletype = special_file();
				if (logfiletype != 0)
				{
    	            f=new File(System.getProperty("user.dir"), "csv.tmp");
    	        }
			}
	        if (logfiletype != 0)
	        {
       	        rf1 = new RandomAccessFile(f, "r");
       	        toggle_controls();
	        }
	        if (logfiletype == 1)
	            dab_header();
	        else
	            if (logfiletype == 2)
	                tlg_header();
	            else
	                error_rtn("Not a supported log file type (dab or tlg)");
	    }
	    catch (IOException ioe)
	    {
		    error_rtn("1) Unable to open file: " + ioe);
	    }
        clear_controls();
        reset_button.setEnabled(true);
        reset_button.setVisible(true);
        animate_control.setVisible(true);
        chart_all.setVisible(true);
        show_low_values.setVisible(true);
        setTitle("Process log file: " + theFileDir + theFile);
	    if (logfiletype == 1)
	    {
	        itc_animate.setVisible(false);
	        afc_animate.setVisible(false);
	        afc2_animate.setVisible(false);
	    }
	    else
	    if (logfiletype == 2)
	    {
	        itc_animate.setVisible(true);
	        afc_animate.setVisible(true);
	        afc2_animate.setVisible(true);
	    }
	}

	void closeFile_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.

		reset_button.setVisible(false);
		reset_button.setEnabled(false);
        animate_control.setVisible(false);
        animate_control.setSelected(false);
        chart_all.setVisible(false);
        show_low_values.setVisible(false);
        itc_animate.setVisible(false);
        afc_animate.setVisible(false);
        afc2_animate.setVisible(false);
		if (itc_frame != null)
		    itc_frame.setVisible(false);
		if (afc_frame != null)
		    afc_frame.setVisible(false);
		if (afc2_frame != null)
		    afc2_frame.setVisible(false);
		if (pms_frame != null)
		    pms_frame.setVisible(false);
		toggle_controls();
		current_log_record = 0;
		max_rpms.setEnabled(false);
		max_o2_voltage.setEnabled(false);
		max_timing.setEnabled(false);
		max_pulse_width.setEnabled(false);
		max_knock.setEnabled(false);
		cell_locked = null;
		Data_Display.setForeground(java.awt.Color.black);
		clear_controls();
		try
		{
	    rf1.close();
		}
		catch (IOException ioe)
		{
		    error_rtn("2) Unable to open file: " + ioe);
		}
		logfiletype = 0;
	}

	void toggle_controls()
	{
	    file_slider.setValue(0);
	    open_file.setEnabled(!open_file.isEnabled());
	    close_file.setEnabled(!close_file.isEnabled());
	    single_backward.setEnabled(!single_backward.isEnabled());
	    single_forward.setEnabled(!single_forward.isEnabled());
	    rewind_button.setEnabled(!rewind_button.isEnabled());
	    play_button.setEnabled(!play_button.isEnabled());
	    chart_button.setEnabled(!chart_button.isEnabled());
	    chart3d.setEnabled(!chart3d.isEnabled());
	    file_slider.setEnabled(!file_slider.isEnabled());
	}

	void dab_header()
	{
	    if (logfiletype != 1)
	        return;
	    try
	    {
	        log_records = ((rf1.length() - 64) / 64);
//	        if (log_records > 2000)
//	            log_records = 2000;
	        log_record_length = 64;
	        first_record = 64;
	        file_slider.setMinimum(0);
	        file_slider.setMaximum((int)log_records);
	        //getfloat(null);
	        if (f1x != null)
	        {
	            rf1x.close();
	            f1x = null;
	        }
	    }
	    catch (IOException ioe)
	    {
		    error_rtn("3) Unable to open file: " + ioe);
	    }
	}

	void tlg_header()
	{
        int drb_temp;
        int drb_byte;
        int drb_temp1;

        long seek_loc;

        if (logfiletype != 2)
            return;
        //getfloat(null);
        try
	    {
    	    if (f1x != null)
	        {
	            rf1x.close();
	            f1x = null;
	        }
		    seek_loc = 4;
		    rf1.seek(seek_loc);
		    drb_byte = rf1.readByte();
		    drb_temp = (int) drb_byte;
		    // read header
		    if (drb_temp > 0)
		    do
			    {
				    rf1.readByte();
				    drb_temp = drb_temp - 1;
			    }
		    while (drb_temp > 0);
		    drb_byte = rf1.readByte();
		    drb_parm_count = (int) drb_byte;
		    System.out.println(drb_parm_count);
		    rf1.readByte();
		    rf1.readByte();
		    drb_temp = 0;
		    do
			    {
				    seek_loc = rf1.getFilePointer();
				    seek_loc = seek_loc + 9;
				    rf1.seek(seek_loc);
				    drb_byte = rf1.readByte();
				    // read desc
				    drb_temp1 = 0;
				    if (drb_byte > 0)
					    do
						    {
							    rf1.readByte();
							    ++drb_temp1;
						    }
					    while(drb_temp1 < (int)drb_byte);
				    rf1.seek(rf1.getFilePointer() + 4);
				    drb_type[drb_temp + 1] = rf1.readByte();
				    System.out.println(drb_type[drb_temp + 1]);
				    drb_type[drb_temp + 1] = drb_type[drb_temp + 1] + 1;
				    rf1.seek(rf1.getFilePointer() + 11);
				    drb_byte = rf1.readByte();
				    drb_temp1 = 0;
				    if (drb_byte > 0)
					    do
						    {
							    rf1.readByte();
							    ++drb_temp1;
						    }
					    while(drb_temp1 < (int)drb_byte);
				    rf1.readByte();
				    rf1.readByte();
				    rf1.readByte();
				    ++ drb_temp;
			    }
		    while (drb_temp < drb_parm_count);

		    // process data frames

		    rf1.seek(rf1.getFilePointer() + 5);
		    first_record = rf1.getFilePointer();
            log_records = ((rf1.length() - first_record) / ((drb_parm_count + 1) * 4));
            //System.out.println("LOG " + log_records);
            //System.out.println(rf1.length() + " " + first_record + " " +  drb_parm_count);
//            System.out.println(rf1.length() + " " + first_record + " " + drb_parm_count);
//            if (log_records > 2000)
//                log_records = 2000;
//            drb_parm_count += 1;
            log_record_length = (drb_parm_count + 1) * 4;
	        file_slider.setMinimum(0);
	        file_slider.setMaximum((int)log_records);
	        file_slider.setSnapToTicks(false);
//	        System.out.println(log_records);
        }
        catch (IOException ioe)
        {
		    error_rtn("4) Unable to open file: " + ioe);
        }
	}

	void singleBackward_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(-1);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void point_log_file(long delta)
	{
	    long offset;
	    int loop;

	    if (logfiletype != 1 && logfiletype != 2)
	        return;

	    if (delta == 0)
	    {
	        current_log_record = 0;
	        offset = first_record;
	    }
	    else
	        if (delta > 1)
	        {
	            current_log_record = delta;
		        offset = (long)((current_log_record * log_record_length) + first_record);
	        }
	        else
	        {
		        current_log_record = current_log_record + delta;
		        if (current_log_record < 0)
		            current_log_record = 0;
		        offset = (long)((current_log_record * log_record_length) + first_record);
		        System.out.println(offset + " = " + current_log_record + " " + log_record_length + " " + first_record);
		    }
		try
		{
		    if (offset > rf1.length() - log_record_length)
		        {
		            offset = rf1.length() - log_record_length;
		            current_log_record = log_records;
		        }
		    rf1.seek(offset);
		}
		catch (IOException ioe)
		{
		    error_rtn("5) Unable to open file: " + ioe);
		}
		if (chartcontrol_frame == null)
		    reset_charts();
		if (chartcontrol_frame != null)
		{
		    for (loop=1;loop<=max_charts;loop++)
		        if (chart_frames[loop] != null)
		        {
		            if (chart_frames[loop].chart_window.chart_loaded && !chart_frames[loop].chart_window.local_scroll)
		            {
       	                if (chart_frames[loop].chart_window.isVisible())
       	                {
                            chart_frames[loop].chart_window.scrollmark(current_log_record + 1);
                            chart_frames[loop].chart_window.update_status();
                        }
    //                    chart_frames[loop].chart_window.local_scroll = false;    
		            }
		        }
		}
		if (single_click)
		{
		    file_slider.setValue((int)current_log_record);
		}
	}

	void singleForward_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
//		dump_log_record();
		point_log_file(1);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void rewindButton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	class SymPropertyChange implements java.beans.PropertyChangeListener
	{
		public void propertyChange(java.beans.PropertyChangeEvent event)
		{
			Object object = event.getSource();
			if (object == file_slider)
				fileSlider_propertyChange(event);
		}
	}

	void fileSlider_propertyChange(java.beans.PropertyChangeEvent event)
	{
		// to do: code goes here.
		if (!single_click)
		{
		    point_log_file(0);
		    point_log_file(file_slider.getValue());
		    read_log_record();
		    display_log_record();
		}
	}

	class SymChange implements javax.swing.event.ChangeListener
	{
		public void stateChanged(javax.swing.event.ChangeEvent event)
		{
			Object object = event.getSource();
			if (object == file_slider)
				fileSlider_stateChanged(event);
			else if (object == o2_slider)
				o2Slider_stateChanged(event);
		}
	}

	void fileSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
		// to do: code goes here.
		if (!single_click)
		{
		    point_log_file(0);
		    point_log_file(file_slider.getValue());
		    read_log_record();
		    display_log_record();
		}
	}

	void playButton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		clear_controls();
        rewindButton_mouseClicked(null);
        play_data();
	}

	void play_data()
	{
	    do
	    {
	        single_click = true;
	        point_log_file(1);
	        read_log_record();
	        display_log_record();
//	        current_log_record ++;
	        single_click = false;
	    }
	    while (current_log_record < log_records);
	}

	void read_log_record()
	{
        if (logfiletype == 1)
            read_pms_record();
        else
            if (logfiletype == 2)
                read_drb_record();
	}

	void read_drb_record()
	{
	    int  drb_temp;
	    byte drb_byte;
	    int  drb_temp1;
	    Float tf;
	    float ta;

		drb_data_fields[0] = getfloat(rf1);
		System.out.println("fill " + drb_data_fields[0]);
		// get the data parms
		drb_temp = 1;
		do
			{
				drb_data_fields[drb_type[drb_temp]] = getfloat(rf1);
				System.out.println("data " + (drb_type[drb_temp] - 1) + " " + drb_data_fields[drb_type[drb_temp]]);
				++ drb_temp;
			}
		while (drb_temp <= drb_parm_count);
        drb_rpms = (int)drb_data_fields[10];
	    drb_timing = (byte)drb_data_fields[1];
	    drb_pulsewidth = drb_data_fields[11];
	    drb_watertemp = (int)drb_data_fields[2];
	    o2_target = drb_data_fields[4];
	    drb_o2voltage = trim_decimals(drb_data_fields[4]);
	    drb_airtemp = (int)drb_data_fields[12];
	    drb_tps = (byte)drb_data_fields[8];
	    drb_pressure = 0;
	    drb_knock = (byte)drb_data_fields[18];
	    drb_afhz = drb_data_fields[19];
	    drb_mph = (int)drb_data_fields[91];
	    drb_map = (int)drb_data_fields[92];
	    drb_s2 = (int)drb_data_fields[93];
	    drb_l2 = (int)drb_data_fields[94];
	    drb_s1 = (int)drb_data_fields[13];
	    drb_l1 = (int)drb_data_fields[14];
	    drb_load = (int)drb_data_fields[95];
	    drb_o2 = drb_data_fields[96];
	    drb_ticks = (int)drb_data_fields[97];
	    drb_o2trim = (int)drb_data_fields[16];
	    drb_mtrim = (int)drb_data_fields[49];
	    if (o2_slider.isEnabled())
            o2_slider.setEnabled(false);
//        if (advanced_fuel_calc.isVisible())
  //          advanced_fuel_calc.setVisible(false);
        reset_cell();
    }

    void reset_cell()
    {
        if (cell_locked != null)
        {
            cell_locked = null;
            Data_Display.setForeground(java.awt.Color.black);
        }
    }

	void read_pms_record()
	{

		short temp_short;
		int   temp_int;
		char  temp_char;
		byte  temp_byte;
		byte  ub1;
		byte  ub2;
		byte  ub3;


        try
        {
		    rf1.seek(rf1.getFilePointer() + 2);
            ub1 = rf1.readByte();
            ub2 = rf1.readByte();
            ub3 = rf1.readByte();
//            System.out.println(ub1 + " " + ub2 + " " + ub3);
		    ub1 = rf1.readByte(); // read rpm lob
		    ub2 = rf1.readByte(); // read spm hob
		    pms_ecu_rpms = build_int(ub2, ub1);
		    pms_ecu_rpms = pms_ecu_rpms * 10;
		    pms_ecu_timing = rf1.readByte(); // read timing
		    pms_timing = rf1.readByte(); // read pms timing
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // read ecu pulse width lob
		    ub2 = rf1.readByte(); // read ecu pulse width hob
		    pms_ecu_pulsewidth = (float)(build_int(ub2, ub1)) * .1388F;
		    pms_ecu_pulsewidth = trim_decimals(pms_ecu_pulsewidth);
		    ub1 = rf1.readByte(); // read pms pulse width lob
		    ub2 = rf1.readByte(); // read pms pulse width hob
		    pms_pulsewidth = (float)(build_int(ub2, ub1)) * .1388F;
		    pms_pulsewidth = trim_decimals(pms_pulsewidth);
		    ub1 = rf1.readByte(); // discard byte
		    pms_watertemp = (int)rf1.readByte();  // read water temp
		    if (pms_watertemp >= 0)
		      temp_int = pms_watertemp;
		    else
		      temp_int = pms_watertemp  -1;
		    temp_int = (266 - (temp_int * 3)) + 3;
		    pms_watertemp = temp_int;
		    ub1 = rf1.readByte(); // discard byte
		    ub2 = rf1.readByte(); // discard byte
		    temp_byte = rf1.readByte(); // read o2 voltage
		    pms_o2voltage = (float)(temp_byte * .02) - .02F;
		    o2_target = pms_o2voltage;
		    pms_o2voltage = trim_decimals(pms_o2voltage);
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // read intake air temp
		    ub2 = 0;
		    pms_airtemp = (byte)build_int((byte)0, ub1);
		    if (pms_airtemp < 0)
		      temp_int = pms_airtemp * -1;
		    else
		      temp_int = pms_airtemp;
		    temp_int = 5 + (196 - temp_int);
		    pms_airtemp = temp_int;
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // discard byte
		    pms_tps = rf1.readByte(); // read tps
		    ub1 = rf1.readByte(); // discard byte
		    ub2 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // discard byte
		    ub1 = rf1.readByte(); // manifold pressure lob
		    ub2 = rf1.readByte(); // manifold pressure hob
		    temp_int = ub1;
		    temp_int = ub2;
    	    temp_int = (int) ((ub2 << 8) | ub1);
    	    pms_pressure = (float)(temp_int * .1);
    	    if ((ub2 == 0 || ub2 == -2) && ub1 < 0)
    	        {
    	            pms_pressure = (float) (pms_pressure + 25.5);
    	            if (ub2 == -2 && pms_pressure > 0)
    	                {
    	                    pms_pressure = (float)(pms_pressure * -1);
    	                }
    	        }
    	    pms_pressure = trim_decimals(pms_pressure);
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    pms_hz = build_int(ub2,ub1);
		    ub1 = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    pms_fueladdition = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    ub2 = rf1.readByte();
		    ub1 = rf1.readByte();
		    pms_timingaddition = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    ub1 = rf1.readByte();
		    ub2 = rf1.readByte();
		    ub1 = rf1.readByte();
		    pms_acc = rf1.readByte();
		    temp_byte = (byte)((pms_acc / 2) * 2);
		    if (temp_byte != pms_acc)
		        pms_acc = 1;
		    else
		        pms_acc = 0;
        }
        catch (Exception e)
        {
        }
	    if (o2_slider.isEnabled())
            o2_slider.setEnabled(false);
//        if (advanced_fuel_calc.isVisible())
  //          advanced_fuel_calc.setVisible(false);
        reset_cell();

	}



	public float getfloat(RandomAccessFile rfinput)
	{
		byte nibbles[] = new byte[4];

		float flt;

		flt = 0;
		try
		{
/*			if (rfinput == null)
			{
			    if (f1x != null)
				    rf1x.close();
				f1x = null;
				return 0F;
	     		} */
	     	if (csv_file)
	     	{
				return trim_decimals(rfinput.readFloat());
			}
			if (f1x == null)
			{
				f1x = new File(System.getProperty("user.dir"), "float.tmp");
				rf1x = new RandomAccessFile(f1x, "rw");
			}
			nibbles[3] = rfinput.readByte();
			nibbles[2] = rfinput.readByte();
			nibbles[1] = rfinput.readByte();
			nibbles[0] = rfinput.readByte();
			rf1x.seek(0);
			rf1x.writeByte(nibbles[0]);
			rf1x.writeByte(nibbles[1]);
			rf1x.writeByte(nibbles[2]);
			rf1x.writeByte(nibbles[3]);
			rf1x.seek(0);
			flt = rf1x.readFloat();
		}
		catch (IOException ioe)
		{
		    error_rtn("6) Unable to open file: " + ioe);
		}
		return trim_decimals(flt);
	}

	void display_log_record()
	{
        if (logfiletype == 1)
            display_pms_record();
        else
            if (logfiletype == 2)
                display_drb_record();
	}

	void display_pms_record()
	{
	    float tf = 0f;

	    if (pms_ecu_rpms > 8000)
	        return;
	    rtd_line = "{" + Long.toString(current_log_record) + "}";
		rtd_line = rtd_line + " Rpms: " + Integer.toString(pms_ecu_rpms);
		rtd_line = rtd_line + "  Prs/Vac ";
		rtd_line = rtd_line + Float.toString(pms_pressure);
	    if (cell_locked != null && adjust_fuel_pcnt != 0)
	    {
	        //if (cell_locked != display_cells[1][0])
    		    cell_locked.setText(Float.toString(trim_decimals(adjust_fuel_o2)));
	    }
		rtd_line = rtd_line + "\nTPS: " + Byte.toString(pms_tps);
		if (pms_airtemp != 0)
		    rtd_line = rtd_line + "  Air: " + Integer.toString(pms_airtemp);
		if (pms_watertemp != 0)
            rtd_line = rtd_line + "  Clt: " + Integer.toString(pms_watertemp);
		rtd_line = rtd_line + "  O2: ";
		//if (cell_locked == null)
		    rtd_line = rtd_line + Float.toString(pms_o2voltage);
		//else
		  //  rtd_line = rtd_line + Float.toString(trim_decimals(adjust_fuel_o2));
		rtd_line = rtd_line + "\nTiming " + Byte.toString(pms_ecu_timing);
		if (pms_timingaddition != 0)
		    {
	        	rtd_line = rtd_line + "/" + Byte.toString(pms_timing);
                rtd_line = rtd_line + "(";
    	        rtd_line = rtd_line + Byte.toString(pms_timingaddition) + ")";
    	    }
		rtd_line = rtd_line + " Dc:" + Float.toString(trim_decimals((pms_pulsewidth * pms_ecu_rpms) / 1200F));
		rtd_line = rtd_line + "%";
		if (pms_acc != 0)
		    rtd_line = rtd_line + " NOS";
		rtd_line = rtd_line + "\nFuel(pw) " + Float.toString(pms_ecu_pulsewidth);
		adjust_fuel_pw = pms_pulsewidth;
        pulse_ratio = pms_o2voltage / ((float)pms_ecu_rpms / (pms_pulsewidth * 100));
        adjust_fuel_o2 = 0;
	    if (afr_frame != null && (pms_ecu_rpms >= rpmrange_value || pms_tps >= tpsrange_value))
	    {
            // 0 - 02's
            // 1 - timing
            // 2 - air flow
            // 3 - pulse width
            // 4 - duty cycle
      	    afr_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc, pms_o2voltage, 0, show_low_values.isSelected());
      	    afr_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc, pms_timing, 1, show_low_values.isSelected());
      	    afr_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc, (float)pms_hz, 2, show_low_values.isSelected());
      	    afr_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc, pms_pulsewidth, 3, show_low_values.isSelected());
      	    afr_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc, trim_decimals((pms_pulsewidth * pms_ecu_rpms) / 1200F), 4, show_low_values.isSelected());
      	}
        if (pms_frame != null && animate_control.isSelected())
	    {
	        if (pms_frame != null)
	        {
	            pms_frame.adjust_pcnt = -100;
	            //if (cell_locked != display_cells[1][0])
	                pms_frame.adjust_pcnt = /*pms_fueladdition - */ adjust_fuel_pcnt;
	        }
	        pms_frame.animate_cells(pms_ecu_rpms, pms_tps, pms_pressure, pms_acc);
            adjust_fuel_pcnt = pms_frame.total_adjust;
            // calc new pulsewidth
            tf = adjust_fuel_pw - (adjust_fuel_pw * ((float)adjust_fuel_pcnt / 100));
            // calc new o2 voltage
            adjust_fuel_o2 = ((float)pms_ecu_rpms / (tf * 100)) * pulse_ratio;
            adjust_fuel_pw = adjust_fuel_pw + (adjust_fuel_pw * ((float)adjust_fuel_pcnt / 100));
	    }
	    else
	        adjust_fuel_pcnt = 0;
		if (pms_fueladdition != 0 || cell_locked != null)
		    if (cell_locked == null)
		    {
        		rtd_line = rtd_line + "/" + Float.toString(trim_decimals(adjust_fuel_pw));
		        rtd_line = rtd_line + "(" + Integer.toString(pms_fueladdition + adjust_fuel_pcnt) + "%)";
		    }
		    else
		    {
        		rtd_line = rtd_line + "/" + Float.toString(trim_decimals(adjust_fuel_pw));
		        rtd_line = rtd_line + "(" + Integer.toString(adjust_fuel_pcnt + pms_fueladdition) + "%)";
		    }
		if (adjust_fuel_pcnt != 0)
		    rtd_line = rtd_line + "(" + Float.toString(trim_decimals(adjust_fuel_o2)) + ")";
		rtd_line = rtd_line + " Hz:" + pms_hz;
	    Data_Display.setText(rtd_line);
	    if (adjust_fuel_pcnt == 0)
            set_peak_values(pms_timing, (byte)0, pms_pulsewidth, pms_ecu_rpms, pms_o2voltage, current_log_record, pms_pressure, (int)pms_tps, pms_fueladdition + adjust_fuel_pcnt, pms_airtemp, pms_watertemp);
        else
            set_peak_values(pms_timing, (byte)0, pms_pulsewidth, pms_ecu_rpms, adjust_fuel_o2, current_log_record, pms_pressure, (int)pms_tps, pms_fueladdition + adjust_fuel_pcnt, pms_airtemp, pms_watertemp);
	}

	void display_drb_record()
	{
        float p = 0F;
        int t = 0;
        if (drb_rpms > 8000)
            return;
	    if (animate_control.isSelected())
	    {
            if (itc_frame != null)
                if (itc_frame.isVisible())
                    itc_frame.animate_cells(drb_rpms);
            if (afc_frame != null)
                if (afc_frame.isVisible())
                    afc_frame.animate_cells(drb_rpms);
            if (afc2_frame != null)
                if (afc2_frame.isVisible())
                    afc2_frame.animate_cells(drb_rpms, (int)drb_tps);
        }
	    rtd_line = "{" + Long.toString(current_log_record) + "}";
		rtd_line = rtd_line + " Rpms: " + Integer.toString(drb_rpms);
		rtd_line = rtd_line + "  Prs/Vac ";
		rtd_line = rtd_line + Float.toString(drb_pressure);
		rtd_line = rtd_line + " O2: " ;
	    rtd_line = rtd_line + Float.toString(drb_o2voltage);
	    if (drb_o2 != 0)
	        rtd_line = rtd_line + "/" + Float.toString(drb_o2);
		rtd_line = rtd_line + "\nTPS: " + Byte.toString(drb_tps);
		if (drb_airtemp != 0)
		    rtd_line = rtd_line + "  Air: " + Integer.toString(drb_airtemp);
		if (drb_watertemp != 0)
            rtd_line = rtd_line + "  Clt: " + Integer.toString(drb_watertemp);
		rtd_line = rtd_line + " Dc:" + Float.toString(trim_decimals((drb_pulsewidth * drb_rpms) / 1200F));
		rtd_line = rtd_line + "%\nTiming " + Byte.toString(drb_timing);
		t = (int)drb_timing;
		if (itc_frame != null && animate_control.isSelected())
		    if (itc_frame.adjustPercentage != 0 && itc_frame.isVisible())
		    {
		        t = (int)drb_timing + itc_frame.adjustPercentage;
		        rtd_line = rtd_line + "/" + Integer.toString(t);
		        rtd_line = rtd_line + "(" + Integer.toString(itc_frame.adjustPercentage) + ")";
		    }
		rtd_line = rtd_line + "  Knock: " + Byte.toString(drb_knock);
		rtd_line = rtd_line + "\nFuel(pw) " + Float.toString(drb_pulsewidth);
		p = 0F;
		if (afc_frame != null && animate_control.isSelected())
		    if (afc_frame.isVisible())
		        p = (float)afc_frame.adjustPercentage;
		if (afc2_frame != null && animate_control.isSelected())
		    if (afc2_frame.isVisible())
		        p = (float)afc2_frame.adjustPercentage;
		if (p != 0F)
		{
            rtd_line = rtd_line + "(";
            if (afc_frame != null)
                if (afc_frame.isVisible())
                    rtd_line = rtd_line + Integer.toString(afc_frame.adjustPercentage);
            if (afc2_frame != null)
                if (afc2_frame.isVisible())
                    rtd_line = rtd_line + Integer.toString(afc2_frame.adjustPercentage);
            rtd_line = rtd_line + ")";
		}
		if (cell_locked == null && animate_control.isSelected())
		{
		    tframe = 0;
		    if (afc_frame != null)
		        if (afc_frame.isVisible())
		            tframe = 1;
		    if (afc2_frame != null)
		        if (afc2_frame.isVisible())
		            tframe = 2;
		    if (tframe != 0)
            {
                int adjustDelta = 0;
                if (tframe == 1)
	                adjustDelta = afc_frame.adjustDelta;
		        if (tframe == 2)
		            adjustDelta = afc2_frame.adjustDelta;
                if (tframe != 0)
                    {
                        pulse_ratio = drb_o2voltage / ((float)drb_rpms / (drb_pulsewidth * 100));
                        if (adjustDelta < 0)
                        {
                            adjust_fuel_pw = drb_pulsewidth + (drb_pulsewidth * ((float)adjustDelta / 100));
                            adjust_fuel_o2 = ((float)drb_rpms / (adjust_fuel_pw * 100)) * pulse_ratio;
                            adjust_fuel_pw = drb_pulsewidth - (drb_pulsewidth * ((float)adjustDelta / 100));
                        }
                        else
                        {
                            adjust_fuel_pw = drb_pulsewidth - (drb_pulsewidth * ((float)adjustDelta / 100));
                            adjust_fuel_o2 = ((float)drb_rpms / (adjust_fuel_pw * 100)) * pulse_ratio;
                            adjust_fuel_pw = drb_pulsewidth + (drb_pulsewidth * ((float)adjustDelta / 100));
                        }
                        //new_o2 = ((float)base_rpms / (base_pw * 100)) * pulse_ratio;
		                rtd_line = rtd_line + "/" + Float.toString(trim_decimals(adjust_fuel_pw));
		                rtd_line = rtd_line + "(" + Integer.toString(adjustDelta) + ")";
		                rtd_line = rtd_line + "|" + Float.toString(trim_decimals(adjust_fuel_o2));
                        set_peak_values((byte)t, drb_knock, trim_decimals(adjust_fuel_pw), drb_rpms, trim_decimals(adjust_fuel_o2), current_log_record, 0F, (int) drb_tps, 0, drb_airtemp, drb_watertemp);
                    }
                    else
                        set_peak_values((byte)t, drb_knock, drb_pulsewidth, drb_rpms, drb_o2voltage, current_log_record, 0F, (int) drb_tps, 0, drb_airtemp, drb_watertemp);
                }
                else
                    set_peak_values((byte)t, drb_knock, drb_pulsewidth, drb_rpms, drb_o2voltage, current_log_record, 0F, (int) drb_tps, 0, drb_airtemp, drb_watertemp);
		    }
		    else
              set_peak_values((byte)t, drb_knock, drb_pulsewidth, drb_rpms, drb_o2voltage, current_log_record, 0F, (int) drb_tps, 0, drb_airtemp, drb_watertemp);

		if (cell_locked != null)
		{
		    rtd_line = rtd_line + "/" + Float.toString(adjust_fuel_pw);
		    rtd_line = rtd_line + "(" + Integer.toString(adjust_fuel_pcnt) + ")";
		    rtd_line = rtd_line + "|" + Float.toString(trim_decimals(adjust_fuel_o2));
		    //if (cell_locked != display_cells[1][0])
		    cell_locked.setText(Float.toString(trim_decimals(adjust_fuel_o2)));
		    if (animate_control.isSelected())
		    {
    		    //error_rtn("Updating maps, please wait");
		        if (afc_frame != null)
		            if (afc_frame.isVisible())
    		            afc_frame.control_simulator(drb_rpms, adjust_fuel_pcnt, fuel_base);
    		    if (afc2_frame != null)
    		        if (afc2_frame.isVisible())
    		        {
    		            afc2_frame.control_simulator(drb_rpms, adjust_fuel_pcnt, fuel_base, drb_tps);
    		        }
    		    //error_diag.setVisible(false);    
    		}
		}
		rtd_line = rtd_line + " Hz:" + drb_afhz;
		rtd_line = rtd_line + " MPH:" + drb_mph;
		if (drb_mph != 0 || drb_map != 0 || drb_load != 0)
		    rtd_line = rtd_line + "\n";
		if (drb_mph != 0)
		    rtd_line = rtd_line + "MPH: " + Integer.toString(drb_mph) + " ";
		if (drb_map != 0)
		    rtd_line = rtd_line + "MAP: " + Integer.toString(drb_map) + " ";
		if (drb_load != 0)
		    rtd_line = rtd_line + "Load: " + Integer.toString(drb_load) + " ";
		if (drb_s1 != 0 || drb_s2 != 0 || drb_l1 != 0 || drb_l2 != 0)
	        rtd_line = rtd_line + "\n";
	    if (drb_s1 != 0 || drb_s1 != 0 || drb_o2trim != 0)
	        rtd_line = rtd_line +  "STrim ";
	    if (drb_s1 != 0)
	        rtd_line = rtd_line + "1: " + Integer.toString(drb_s1) + " ";
	    if (drb_s2 != 0)
	        rtd_line = rtd_line + "2: " + Integer.toString(drb_s2) + " ";
	    if (drb_l1 != 0 || drb_l1 != 0)
	        rtd_line = rtd_line +  "LTrim ";
	    if (drb_l1 != 0)
	        rtd_line = rtd_line + "1: " + Integer.toString(drb_l1) + " ";
	    if (drb_l2 != 0)
	        rtd_line = rtd_line + "2: " + Integer.toString(drb_l2) + " ";
	    if (drb_o2trim != 0)
	        rtd_line = rtd_line + "O2 Trim: " + Integer.toString(drb_o2trim) + " ";
	     
	    Data_Display.setText(rtd_line);

	}

    void set_peak_values(byte timing, byte knock, float pulsewidth, int rpms, float o2_volts, long log_rec, float boost, int tps, int fuel, int at, int wt)
    {
        int rpm_index;

        if (cell_locked != null)
            return;

        rpm_index = (rpms / 500);
        o2_slider.setValue((int)(o2_volts * 100F));
        if (chart_3d)
        {
            if ((!chart_all.isSelected() && (rpms >= rpmrange_value || tps >= tpsrange_value)) || chart_all.isSelected())
            {
                log_3d((float)rpms, o2_volts, (float)fuel, (float)timing, (float)tps, boost, pulsewidth, (float)wt, (float)at);
            }
        }
        if (c2d_frame != null && chart_2d)
            if ((!chart_all.isSelected() && (rpms >= rpmrange_value || tps >= tpsrange_value)) || chart_all.isSelected())
                if (!c2d_frame.isVisible() && c2d_frame.chart2d_values.getRowCount() < 1000)
                {
                    rtd_line1 = Float.toString(boost) + ",";
                    rtd_line1 = rtd_line1 + Byte.toString(knock) + ",";
                    rtd_line1 = rtd_line1 + Byte.toString(timing);
                    if (logfiletype == 1)
                    {
                        rtd_line1 = rtd_line1 + "," + Byte.toString(pms_ecu_timing);
                        rtd_line1 = rtd_line1 + "," + Float.toString((float)tps / 4F);
                    }
                    c2d_frame.chart2d_values.addRow(rtd_line1);
                    rtd_line1 = Float.toString(o2_volts) + ",";
                    rtd_line1 = rtd_line1 + Float.toString(pulsewidth / 10F);
                    if (logfiletype == 1)
                    {
                        rtd_line1 = rtd_line1 + "," + Float.toString(pms_ecu_pulsewidth / 10F);
                        rtd_line1 = rtd_line1 + "," + Float.toString((float)pms_hz / 2000F);
                    }
                    c2d_frame.o2chart_values.addRow(rtd_line1);
                }
        if (chart_2d || chart_3d)
            return;
        if (chart_3d)
            return;
        if (tps < tpsrange_value && rpms < rpmrange_value)
            return;
        pulse_ratio = o2_volts / ((float)rpms / (pulsewidth * 100));

        if (log_analysis[6][rpm_index] < boost)
        {
		    if (!display_cells[3][rpm_index].isEnabled())
		        display_cells[3][rpm_index].setEnabled(true);
		    display_cells[3][rpm_index].setToolTipText("Click to activate the simulator");
            display_cells[3][rpm_index].setText(Float.toString(boost));
            log_analysis[6][rpm_index] = boost;
            log_analysis[2][rpm_index] = (float)log_rec;
        }

        if ((log_analysis[5][rpm_index] < (float)timing && !show_low_values.isSelected()) ||
            (log_analysis[5][rpm_index] > (float)timing && show_low_values.isSelected())  ||
             log_analysis[5][rpm_index] == 0)
        {
		    if (!display_cells[2][rpm_index].isEnabled())
		        display_cells[2][rpm_index].setEnabled(true);
		    display_cells[2][rpm_index].setToolTipText("Click to activate the simulator");
            display_cells[2][rpm_index].setText(Float.toString((float)timing));
            log_analysis[5][rpm_index] = (float)timing;
            log_analysis[1][rpm_index] = (float)log_rec;
        }

        if ((log_analysis[4][rpm_index] < o2_volts && !show_low_values.isSelected()) ||
            (log_analysis[4][rpm_index] > o2_volts && show_low_values.isSelected())  ||
             log_analysis[4][rpm_index] == 0)
        {
		    if (!display_cells[1][rpm_index].isEnabled())
		        display_cells[1][rpm_index].setEnabled(true);
		    display_cells[1][rpm_index].setToolTipText("Click to activate the simulator");
            display_cells[1][rpm_index].setText(Float.toString(o2_volts));
            log_analysis[4][rpm_index] = o2_volts;
            log_analysis[0][rpm_index] = (float)log_rec;
        }

        if (log_analysis[7][rpm_index] < (float)knock && logfiletype == 2)
        {
		    if (!display_cells[4][rpm_index].isEnabled())
		        display_cells[4][rpm_index].setEnabled(true);
		    display_cells[4][rpm_index].setToolTipText("Click to activate the simulator");
		    display_cells[4][rpm_index].setText(Float.toString((float)knock));
            log_analysis[7][rpm_index] = (float)knock;
            log_analysis[3][rpm_index] = (float)log_rec;
        }
        if (log_analysis[7][rpm_index] < (float)pms_hz && logfiletype == 1)
        {
		    if (!display_cells[4][rpm_index].isEnabled())
		        display_cells[4][rpm_index].setEnabled(true);
		    display_cells[4][rpm_index].setToolTipText("Click to activate the simulator");
		    display_cells[4][rpm_index].setText(Integer.toString(pms_hz));
            log_analysis[7][rpm_index] = (float)pms_hz;
            log_analysis[3][rpm_index] = (float)log_rec;
        }

        if ((float)rpms > peak_values[0][0])
        {
            max_rpms.setEnabled(true);
            peak_values[0][0] = (float)rpms;
            peak_values[1][0] = (float)log_rec;
        }
        if (o2_volts > peak_values[0][1])
        {
            max_o2_voltage.setEnabled(true);
            peak_values[0][1] = o2_volts;
            peak_values[1][1] = (float)log_rec;
        }
        if ((float)timing > peak_values[0][2])
        {
            max_timing.setEnabled(true);
            peak_values[0][2] = (float)timing;
            peak_values[1][2] = (float)log_rec;
        }
        if (pulsewidth > peak_values[0][3])
        {
            max_pulse_width.setEnabled(true);
            peak_values[0][3] = pulsewidth;
            peak_values[1][3] = (float)log_rec;
        }
        if ((float)knock > peak_values[0][4])
        {
            max_knock.setEnabled(true);
            peak_values[0][4] = (float)knock;
            peak_values[1][4] = (float)log_rec;
        }
    }

	void maxRpms_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		point_log_file((int)peak_values[1][0]);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void maxO2Voltage_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		point_log_file((int)peak_values[1][1]);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void maxTiming_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		point_log_file((int)peak_values[1][2]);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void maxPulseWidth_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		point_log_file((int)peak_values[1][3]);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void maxKnock_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		single_click = true;
		point_log_file(0);
		point_log_file((int)peak_values[1][4]);
		read_log_record();
		display_log_record();
		single_click = false;
	}

	void add_controls()
	{
	    String headings[] = new String[20];
        int row;
        int x = 48;
        int column;
	    int y = 235;
	    int base_rpm = 500;

	    headings[4] = "";
	    headings[3] = "";
	    headings[2] = "";
	    headings[1] = "";
	    row = 0;
	    do
	    {
	        x = 24;
	        column = 0;
	        do
	        {
                if (row != 0 || column != 0)
                {
            	    display_cells[row][column] = new javax.swing.JTextField();
		            getContentPane().add(display_cells[row][column]);
        		    display_cells[row][column].setFont(new Font("Dialog", Font.PLAIN, 10));
   		            display_cells[row][column].setBounds(x,y,30,18);
		            display_cells[row][column].setEditable(true);
                    display_cells[row][column].setForeground(java.awt.Color.white);
                    display_cells[row][column].setBackground(java.awt.Color.blue);
                    display_cells[row][column].setBorder(bevelBorder1);
                    display_cells[row][column].setVisible(true);
                    if (column == 0 || row == 0)
                    {
    		            display_cells[row][column].setEditable(false);
                        display_cells[row][column].setForeground(java.awt.Color.black);
    		            display_cells[row][column].setBackground(java.awt.Color.green);
    		            if (column == 0 && row > 0)
    		                display_cells[row][column].setText(headings[row]);
                    }
                }
                if (row == 0 && column > 0)
                {
                    display_cells[row][column].setText(Integer.toString(base_rpm));
                    base_rpm = base_rpm + 500;
                }
                x = x + 30;
	            ++ column;
	        }
	        while
	        (column <= 16);
	        y = y + 18;
	        ++ row;
	    }
	    while (row <= 4);
	    first_time = false;
	}

    float trim_decimals(float f)
    {
        int i;
        float f1;
        i = (int)(f * 100F);
        f1 = (float)(i);
        return f1 / 100;

    }

	void clear_controls()
	{
	    String headings[] = new String[20];
        int row;
        int column;
	    int y = 235;
	    int base_rpm = 500;

	    if (chart_3d)
            return;
	    headings[3] = "Psi";
	    headings[4] = "Knck";
	    if (logfiletype == 1)
	      headings[4] = "K Hz";
	    headings[2] = "Tmng";
	    headings[1] = "O2 V";
	    if (c2d_frame != null)
	    {
	        if (c2d_frame.isVisible())
	            c2d_frame.setVisible(false);
	        row = 0;
//	        c2d_frame.chart2d_values.setColumnHeaders("Psi,Knock,Timing");
//	        c2d_frame.o2chart_values.setColumnHeaders("O2v");
	        row = c2d_frame.chart2d_values.getRowCount();
	        if (c2d_frame.chart2d_values.getRowCount() > 0 ||
	            c2d_frame.o2chart_values.getRowCount() > 0)
	        {
	            do
	            {
	                if (c2d_frame.chart2d_values.getRowCount() > 1)
	                    c2d_frame.chart2d_values.removeRow(0);
	                if (c2d_frame.o2chart_values.getRowCount() > 1)
	                    c2d_frame.o2chart_values.removeRow(0);
	            }
	            while(c2d_frame.chart2d_values.getRowCount() > 1 ||
	                  c2d_frame.o2chart_values.getRowCount() > 1);
	        }
	    }
	    if (chart_2d)
	        return;
	    display_cells[1][0].setText(headings[1]);
	    display_cells[2][0].setText(headings[2]);
	    display_cells[3][0].setText(headings[3]);
	    display_cells[4][0].setText(headings[4]);
	    row = 1;
	    do
	    {
	        column = 1;
	        do
	        {
	            if (row <= 4)
	            {
	                display_cells[row][column].setText("");
	                display_cells[row][column].setEnabled(false);
	                display_cells[row][column].setToolTipText(null);
	            }
	            log_analysis[row - 1][column - 1] = 0;
	            ++ column;
	        }
	        while
	        (column <= 16);
	        ++ row;
	    }
	    while (row <= 8);
	}


	void maxKnock_mouseEntered(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

    void show_values(Object object)
    {
        int row;
        int column;

        row = 1;
        do
        {
            column = 1;
            do
            {
                if (object == display_cells[row][column])
                {
                    if (cell_locked == null)
                    {
                        if (log_analysis[row - 1][column] <= 0 || log_analysis[row - 1][column] > log_records)
                            return;
		                single_click = true;
		                point_log_file(0);
	                    point_log_file((int)log_analysis[row - 1][column]);
		                read_log_record();
		                display_log_record();
		                single_click = false;
		            }
		            if (cell_locked != null)
		                display_cells[row][column].setText(Float.toString(adjust_fuel_o2));
                    return;
                }
                ++ column;
            }
            while(column <= 16);
            ++ row;
        }
        while (row <= 4);
    }


	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == animate_control)
				animateControl_itemStateChanged(event);
		}
	}

	void animateControl_itemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.

		int cnt = 0;

		if (animate_control.isSelected())
		{
		    if (logfiletype == 1)
		    {
		        if (afc_frame != null)
		            afc_frame.setVisible(false);
		        if (afc2_frame != null)
		            afc2_frame.setVisible(false);
		        if (itc_frame != null)
		            itc_frame.setVisible(false);
			    if (pms_frame == null)
			        pms_frame = new PMSframe();
			    if (reg_flag == 0 && pms_frame != null)
			    {
			        pms_frame.update_button.setVisible(false);
//			        pms_frame.load_from_pms.setVisible(false);
			        pms_frame.save_to_pms.setVisible(false);
			    }
		        if (pms_frame !=  null)
		            pms_frame.setVisible(true);
		    }
		    if (logfiletype == 2)
		        {
		            if (pms_frame != null)
		                pms_frame.setVisible(false);
		            if (afc_animate.isSelected())
		                ++ cnt;
		            if (afc2_animate.isSelected())
		                ++ cnt;
		            if (cnt > 1)
		            {
		                error_rtn("Too many fuel controller windows are visible!");
		                animate_control.setSelected(false);
		                return;
		            }
		            try
		            {
		                if (!itc_animate.isSelected() && itc_frame != null)
		                    itc_frame.setVisible(false);
		                if (!afc2_animate.isSelected() && afc2_frame != null)
		                {
		                    afc2_frame.setVisible(false);
		                }
		                if (!afc_animate.isSelected() && afc_frame != null)
		                    afc_frame.setVisible(false);
                        if (itc_animate.isSelected())
                        {
                            if (itc_frame == null)
                                itc_frame = new ITCframe1();
                            itc_frame.setVisible(true);
                            if (reg_flag== 0)
                                itc_frame.Ok_Button.setVisible(false);
                        }
                        if (afc_animate.isSelected())
                        {
                            if (afc_frame == null)
                                afc_frame = new AFCframe1();
                            afc_frame.setVisible(true);
                            if (reg_flag == 0)
                                afc_frame.Ok_Button.setVisible(false);
                        }
                        if (afc2_animate.isSelected())
                        {
                            if (afc2_frame == null)
                                afc2_frame = new AFCframe2();
                            if (reg_flag == 0)
                                afc2_frame.JButton1.setVisible(false);
                            afc2_frame.setVisible(true);
                        }
                    }
                    catch (java.lang.Exception e)
                    {
                    }
		        }
		}
		else
		{
		    if (itc_frame != null)
		        itc_frame.setVisible(false);
		    if (afc_frame != null)
		        afc_frame.setVisible(false);
		    if (afc2_frame != null)
		        afc2_frame.setVisible(false);
		    if (pms_frame != null)
		        pms_frame.setVisible(false);
		}

	}

	void o2slider_update()
	{
		// to do: code goes here.
		int base_rpms = 0;
		float base_pw = 0;
		float new_o2 = 0F;
		int   delta = 0;
		int   d1 = 0;
		int   base = 0;
		float desired_o2 = ((float)(o2_slider.getValue()) / 100);
		if (cell_locked == null)
		    return;
		if (logfiletype == 1)
		{
		    adjust_fuel_limit = 49;
		    base_pw = pms_pulsewidth;
		    adjust_fuel_pw = pms_pulsewidth;
		    base_rpms = pms_ecu_rpms;
		    adjust_fuel_pcnt = 0;
		    base = 2;
		}
		else
		if (logfiletype == 2)
		{
		    if (!afc_animate.isSelected() && !afc2_animate.isSelected())
		        {
		            error_rtn("No fuel controller selected!");
		            return;
		        }
		    if (afc_animate.isSelected())
		        adjust_fuel_limit = 29;
		    if (afc2_animate.isSelected())
		        adjust_fuel_limit = 49;
		    base_pw = drb_pulsewidth;
		    adjust_fuel_pw = drb_pulsewidth;
		    base_rpms = drb_rpms;
		    base = 1;
		}
		if (desired_o2 == o2_target)
	    {
	        if (logfiletype == 1)
	        {
	            adjust_fuel_pcnt = 0; //pms_fueladdition;
	            adjust_fuel_pw = pms_pulsewidth;
	            adjust_fuel_o2 = pms_o2voltage;
	            base = 2;
	        }
	        else
	        if (logfiletype == 2)
	        {
		        adjust_fuel_pcnt = 0;
		        adjust_fuel_pw = 0F;
		        adjust_fuel_o2 = o2_target;
		        base = 1;
		    }
		    display_log_record();
	        return;
	    }
	    if (desired_o2 < o2_target)
	        fuel_base = -1;
	    else
	        fuel_base = 1;
		if (desired_o2 < o2_target)
		    do
		    {
		        if (delta < (adjust_fuel_limit * -1))
		            return;
   		        delta = delta - base;
   		        ++ d1;
		        if (advanced_fuel_calc.isSelected())
		        {
		            if (logfiletype == 1)
		            {
   		                base_pw = pms_pulsewidth * (1F + (float)(d1 * base) * .01F);
   		                adjust_fuel_pw = pms_pulsewidth * (1F - (float)(d1 * base) * .01F);
		            }
		            else
		            if (logfiletype == 2)
		            {
   		                base_pw = drb_pulsewidth * (1F + (float)(d1 * base) * .01F);
   		                adjust_fuel_pw = drb_pulsewidth * (1F - (float)(d1 * base) * .01F);
		            }
		        }
		        else
		        {
   		            base_pw = base_pw * (1F + (float)base * .01F);
   		            adjust_fuel_pw = adjust_fuel_pw * (1F - (float)base * .01F);
   		        }
    		    new_o2 = ((float)base_rpms / (base_pw * 100)) * pulse_ratio;
		    }
		    while (new_o2 > desired_o2);
		else
		    do
		    {
		        if (delta > adjust_fuel_limit)
		            return;
		        ++ d1;
		        delta = delta + base;
		        if (advanced_fuel_calc.isSelected())
		        {
		            if (logfiletype == 1)
		            {
   		                base_pw = pms_pulsewidth * (1F - (float)(d1 * base) * .01F);
   		                adjust_fuel_pw = pms_pulsewidth * (1F + (float)(d1 * base) * .01F);
		            }
		            else
		            if (logfiletype == 2)
		            {
   		                base_pw = drb_pulsewidth * (1F - (float)(d1 * base) * .01F);
   		                adjust_fuel_pw = drb_pulsewidth * (1F + (float)(d1 * base) * .01F);
		            }
		        }
		        else
		        {
   		            base_pw = base_pw * (1F - (float)base * .01F);
   		            adjust_fuel_pw = adjust_fuel_pw * (1F + (float)base * .01F);
   		        }
    		    new_o2 = ((float)base_rpms / (base_pw * 100)) * pulse_ratio;
		    }
		    while (new_o2 < desired_o2);
		if (logfiletype == 2 || logfiletype == 1)
		{
		    adjust_fuel_pw = trim_decimals(adjust_fuel_pw);
		    adjust_fuel_pcnt = delta;
		    adjust_fuel_o2 = new_o2;
		    display_log_record();
		}
	}

	void o2Slider_stateChanged(javax.swing.event.ChangeEvent event)
	{
		// to do: code goes here.
	}

	void o2Slider_mouseReleased(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		boolean ok = false;
		if (!o2_slider.isEnabled())
		    return;
		if (afc_frame != null)
		    if (afc_frame.isVisible())
		        ok = true;
		if (afc2_frame != null)
		    if (afc2_frame.isVisible())
		        ok = true;
		if (pms_frame != null)
		    if (pms_frame.isVisible())
		        ok = true;
        if (ok)
		    o2slider_update();
		else
		    error_rtn("There must be a fuel controller selected before simultion is allowed!");
	}

	class SymFocus extends java.awt.event.FocusAdapter
	{
		public void focusLost(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
			if (object == tpsrange)
				tpsrange_focusLost(event);
			else if (object == rpmrange)
				rpmrange_focusLost(event);
		}

		public void focusGained(java.awt.event.FocusEvent event)
		{
			Object object = event.getSource();
            JTextField jf;
            if (cell_locked != null)
            {
                cell_locked = null;
                Data_Display.setForeground(java.awt.Color.black);
            }
            jf = (JTextField)object;
            jf.selectAll();
            show_values(object);
        }
	}

	void animateControl_focusGained(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.
	}

	void error_rtn(String em)
	{
		try {
			// record_dialog Create and show as non-modal
			if (error_diag == null)
			error_diag = new error_dialog();
			error_diag.error_field.setText(em);
			error_diag.setVisible(true);
		} catch (java.lang.Exception e) {
		}
	}

	void animateControl_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		animateControl_itemStateChanged(null);
	}

	void itcAnimate_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		animateControl_itemStateChanged(null);
	}

	void afcAnimate_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		animateControl_itemStateChanged(null);
	}

	void afc2Animate_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		animateControl_itemStateChanged(null);
	}

	void resetButton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		if (logfiletype == 1)
		{
		    if (pms_frame != null)
		    {
		        pms_frame.reset_sim();
		        pms_frame.display_pgm();
		    }
		}
		else
		if (logfiletype == 2)
		{
		    if (afc_frame != null)
		        afc_frame.recall_cfg1();
		    if (afc2_frame != null)
		        afc2_frame.recall_cfg1();
		}
        playButton_mouseClicked(null);
    }
	int build_int(byte hob, byte lob)
	{
	    int loop = 0;
	    int int_value = 0;

	    do
	    {
	        int_value = int_value + (hob & (1<<loop));
	        ++ loop;
	    }
	    while (loop <= 7);
	    loop = 0;
	    int_value = int_value * 256;
	    do
	    {
	        int_value = int_value + (lob & (1<<loop));
	        ++ loop;
	    }
	    while (loop <= 7);
	    return int_value;
	}

	void chartButton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		chart_2d = true;
		if (c2d_frame == null)
		    c2d_frame = new CHART2Dframe();
		if (x_2d != 0)
		{
		    c2d_frame.setLocation(x_2d, y_2d);
		}
		if (c2d_frame.isVisible())
		    c2d_frame.setVisible(false);
		clear_controls();
//        rewindButton_mouseClicked(null);
        if (logfiletype == 1)
        {
            c2d_frame.chart2d_values.setColumnHeaders("Boost,Knock,Timing,ECU Timing,TPS/4");
            c2d_frame.o2chart_values.setColumnHeaders("O2v,Pulsewidth,ECU Pulsewidth,Hz");
        }
        else
        {
            c2d_frame.chart2d_values.setColumnHeaders("Boost,Knock,Timing");
            c2d_frame.o2chart_values.setColumnHeaders("O2v,Pulsewidth");
        }
        play_data();
        c2d_frame.setVisible(true);
		chart_2d = false;
	}

	void chart3d_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
		try
		{
		    fileOut = new FileOutputStream("3d.dat");
		    bufOut = new BufferedOutputStream(fileOut);
		    logout = new PrintStream(bufOut);
		}
		catch (IOException ioe)
		{
		    error_rtn("8) Unable to open file: " + ioe);
		    return;
		}
		chart_3d = true;
		log_3d(-1F, 0F, 0F, 0F, 0F, 0F, 0F, 0F, 0F);
		clear_controls();
//        rewindButton_mouseClicked(null);
        count_3d = 0;
        play_data();
        logout.close();
        if (count_3d <= 0)
        {
            error_rtn("No records selected for charting");
            return;
        }
		if (c3d_frame != null)
		    c3d_frame.dispose();
		c3d_frame = new CHART3Dframe();
        c3d_frame.setVisible(true);
		chart_3d = false;
	}

	void log_3d(float r, float o, float f, float ta, float t, float p, float pw, float wt, float at)
	{
		int rec_num;
		int rec_limit;
		int buf;

	    if (r == -1F)
	    {
		    for (buf = 0; buf < 100; buf++)
		    {
		        logrecord.insert(buf, " ");
		    }

		// Build headings

		    logrecord.insert(00, "Rpms");
		    logrecord.insert(10, "O2");
		    logrecord.insert(20, "Pressure");
		    logrecord.insert(30, "Timing");
		    logrecord.insert(40, "Tps");
		    logrecord.insert(50, "Fuel");
		    logrecord.insert(60, "P/W");
		    logrecord.insert(70, "W/T");
		    logrecord.insert(80, "A/T");
		    logrecord.insert(90, "Rec");
		    logrecord.insert(99, "\n");
		    logrecord.setLength(100);
		    logout.print(logrecord.toString());
		    logrecord.setLength(0);
		    for (buf = 0; buf < 100; buf++)
		    {
		        logrecord.insert(buf, " ");
		    }
		    logrecord.insert(00, "NUMERIC");
		    logrecord.insert(10, "NUMERIC");
		    logrecord.insert(20, "NUMERIC");
		    logrecord.insert(30, "NUMERIC");
		    logrecord.insert(40, "NUMERIC");
		    logrecord.insert(50, "NUMERIC");
		    logrecord.insert(60, "NUMERIC");
		    logrecord.insert(70, "NUMERIC");
		    logrecord.insert(80, "NUMERIC");
		    logrecord.insert(90, "NUMERIC");
		    logrecord.insert(99, "\n");
		    logrecord.setLength(100);
		    logout.print(logrecord.toString());
            return;
	    }

		for (buf = 0; buf < 100; buf++)
		{
		    logrecord.insert(buf, " ");
		}
		++ count_3d;
    	logrecord.insert(00, r);
    	logrecord.insert(10, o);
    	logrecord.insert(20, p);
    	logrecord.insert(30, ta);
    	logrecord.insert(40, t);
    	logrecord.insert(50, f);
    	logrecord.insert(60, pw);
    	logrecord.insert(70, wt);
    	logrecord.insert(80, at);
    	logrecord.insert(90, current_log_record);
    	logrecord.insert(99, "\n");
        logrecord.setLength(100);
		logout.print(logrecord.toString());
	    logrecord.setLength(0);
	}

	void fileSlider_mouseReleased(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
	}

	int special_file()
	{
	    int a = 0;
	    int b = 0;
	    int ft = 0;
	    int tc = 0;
	    boolean ok = false;
	    Float ft1 = null;
	    
        int    item_index[] = {-2, -1, 9, 17, 3, 7, 0, 1, 12, 10, 98, 99};

		try 
		{
			// Dialog1 Create and show as modal
		    if (csv_diag == null)	
		    {
			    csv_diag = new csv_dialog(this, true);
			    csv_diag.choices[0] = null;
			}
			csv_diag.setVisible(false);
		} catch (java.lang.Exception e) {
		}
//		csv_diag.add_controls(20);
//		csv_diag.setModal(true);
//		csv_diag.get_selected();

	    // open the file
	    // display the first 5 records in the text area
	    // count the # of columns
	    // display the controls
	    BufferedReader csv_in = null;
	    try
	    {
	        csv_in = new BufferedReader(new FileReader(theFileDir + theFile));
	    }
	    catch (FileNotFoundException fnf)
	    {
	        error_rtn("File error: " + fnf);
	    }

	    try
	    {
	        csv_diag.textArea1.setText("");
	        do
	        {
	            rtd_line = csv_in.readLine();
	            StringTokenizer st = new StringTokenizer(rtd_line, ",");
	            csv_diag.textArea1.append(rtd_line + "\n");
	            tc = st.countTokens();
	            if (tc > 1)
	                break;
	            ++ a;
	        }
	        while (a < 5);
	        if (tc > 1)
	        {
	            if (csv_diag.choices[0] == null)
	                csv_diag.add_controls(tc);
	            csv_diag.setVisible(true);
	            csv_diag.setModal(true);
	            if (csv_diag.pms_file.isSelected())
	                ft = 1;
	            if (csv_diag.drb_file.isSelected())
	                ft = 2;
	            if (csv_diag.csv_file.isSelected())
	                ft = 3;
	        }
	        else
	            ft = 0;
	        if (ft != 3)
	            return ft;
	        if (ft == 3)
	        {
	            error_rtn("Converting file, please wait");
	            //set ft to 2

	            // first tokenization, file points to first record after the "headings"

				File f1x = new File(System.getProperty("user.dir"), "csv.tmp");
				if (f1x.exists())
				    f1x.delete();
				RandomAccessFile rf1x = new RandomAccessFile(f1x, "rw");
	            a = 0;
	            int tc1 = 0;
	            do
	            {
	                b = csv_diag.choices[a].getSelectedIndex();
	                if (b > 1)
	                {
	                    if (item_index[b] >= 0 && item_index[b] < 20)
	                        ++ tc1;
	                }
	                ++ a;
	            }
	            while (a < tc);
	            ok = false;
	            rf1x.seek(4);
	            rf1x.writeByte(0); // title length
	            rf1x.writeByte(tc1); // number of parms
	            rf1x.writeShort(0);
	            a = 0;
	            do
	            {
	                b = csv_diag.choices[a].getSelectedIndex();
	                if (b > 1 && b < 20)
	                if (item_index[b] >= 0 && item_index[b] < 20)
	                {
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeByte(0);
	                    rf1x.writeByte(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeByte(item_index[b]);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeByte(0);
	                    rf1x.writeShort(0);
	                    rf1x.writeShort(0);
	                    
	                }
	                if (b > 1)
	                    ok = true;
	                ++ a;
	            }
	            while (a < tc);
	            rf1x.writeShort(0);
	            rf1x.writeShort(0);
                rf1x.writeByte(0);
                a = 0;
                tc1 = 0;
                String token_string;
                do
                {
                    try
                    {
                        rtd_line = csv_in.readLine();
                        if (rtd_line == null)
                            break;
                        a = 0;
                        StringTokenizer st = new StringTokenizer(rtd_line, ",");
                        rf1x.writeFloat(0F);
                        do
                        {
	                        b = csv_diag.choices[a].getSelectedIndex();
	                        token_string = st.nextToken();
	                        if (b > 1 && b < 20)
	                        if (item_index[b] >= 0 && item_index[b] < 20)
                            {
                                ft1 = new Float(token_string);
                                rf1x.writeFloat(ft1.floatValue());
                            }
                            ++ a;
                        }
                        while (a < tc);
                        ++ tc1;
                    }
                    catch(IOException ioe)
                    {
                        break;
                    }
                }
                while (ok);
                
	            rf1x.close();
	            error_diag.setVisible(false);
	        }
    	    csv_in.close();
    	    if (!ok)
    	    {
    	        csv_file = false;
    	        return 0;
    	    }
    	    csv_file = true;
    	    return 2;
	    }
	    catch (IOException ioe)
	    {
	        error_rtn("File error: " + ioe);
	    }

		return 0;
	}

	void PLAYframe_windowOpened(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
	    REGframe reg_frame = null;
	    String key_string = " ";
	    
	    File reg_file = new File(System.getProperty("user.dir") + "\\tnt.reg");
	    if (!reg_file.exists() || !reg_file.isFile())
	      return;
        
		try {
			// REGframe Create and show the REGframe
			reg_frame = new REGframe();
		} catch (java.lang.Exception e) {
		}
		try
		{
            RandomAccessFile reg_filex = new RandomAccessFile(reg_file, "r");
            //loadfield(reg_filex, reg_frame.namefield);
            reg_frame.namefield.setText(reg_filex.readLine());
            reg_frame.address1field.setText(reg_filex.readLine());
            reg_frame.address2field.setText(reg_filex.readLine());
            reg_frame.cityfield.setText(reg_filex.readLine());
            reg_frame.statefield.setText(reg_filex.readLine());
            reg_frame.zipfield.setText(reg_filex.readLine());
            reg_frame.phonefield.setText(reg_filex.readLine());
            reg_frame.emailfield.setText(reg_filex.readLine());
            key_string = reg_filex.readLine();
            int byte_count = 0;
            do
            {
                byte b = reg_filex.readByte();
                reg_filex.readByte();
                reg_frame.reg_flags[byte_count] = 0;
                if (byte_count == 9)
                {
                    if (b == 49)
                      reg_frame.checkbox1.setState(true);
                }
                ++ byte_count;
            }
            while (byte_count < 10);
		    reg_filex.close();
		}
		catch(IOException ioe)
		{
		}
		reg_frame.build_key();
		if (key_string.compareTo(reg_frame.keyfield.getText()) != 0)
		{
		  this.setTitle(this.getTitle() + " - UNREGISTERED");  
		  return;
		}
		reg_frame.keyfield.setVisible(false);
		reg_frame.label6.setVisible(false);
		reg_frame.setVisible(true);
		reg_flag = 1;
	}

	void invisibleButton1_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		invisibleButton1_mouseClicked_Interaction1(event);
	}

	void invisibleButton1_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
	    if (afr_frame == null)
	    {
	        afr_frame = new AFRframe();
	        afr_frame.add_controls();
	    }
	    afr_frame.setVisible(true);
	}
	

    void plot_data()
    {
        int loopa; 
        
        String ot = getTitle();
        
        setTitle(ot + " (loading chart points, please wait)");
        toggle_controls();
        
        rewindButton_mouseClicked(null);
        clear_controls();
	    do
	    {
	        single_click = true;
	        point_log_file(1);
	        read_log_record();
            if (!chart_frames[1].chart_window.isVisible())
            {   
                chart_frames[1].chart_window.setTitle("RPM");
                chart_frames[1].chart_window.chart_low = 0;
                chart_frames[1].chart_window.chart_high = 8000;
            }
            if (!chart_frames[2].chart_window.isVisible())
            {   
                chart_frames[2].chart_window.setTitle("Timing");
                chart_frames[2].chart_window.chart_low = 0;
                chart_frames[2].chart_window.chart_high = 64;
            }
            if (!chart_frames[3].chart_window.isVisible())
            {   
                chart_frames[3].chart_window.setTitle("Pulse Width");
                chart_frames[3].chart_window.chart_low = 0;
                chart_frames[3].chart_window.chart_high = 100;
            }
            if (!chart_frames[4].chart_window.isVisible())
            {   
                chart_frames[4].chart_window.setTitle("Coolant");
                chart_frames[4].chart_window.chart_low = 0;
                chart_frames[4].chart_window.chart_high = 300;
            }
            if (!chart_frames[5].chart_window.isVisible())
            {   
                chart_frames[5].chart_window.setTitle("O2v");
                chart_frames[5].chart_window.chart_low = 0;
                chart_frames[5].chart_window.chart_high = 150;
            }
            if (!chart_frames[6].chart_window.isVisible())
            {   
                chart_frames[6].chart_window.setTitle("Intake Temp");
                chart_frames[6].chart_window.chart_low = 0;
                chart_frames[6].chart_window.chart_high = 250;
            }
            if (!chart_frames[7].chart_window.isVisible())
            {   
                chart_frames[7].chart_window.setTitle("TPS");
                chart_frames[7].chart_window.chart_low = 0;
                chart_frames[7].chart_window.chart_high = 100;
            }
            if (!chart_frames[8].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[8].chart_window.setTitle("Boost");
                chart_frames[8].chart_window.chart_low = 0;
                chart_frames[8].chart_window.chart_high = 30;
            }
            if (!chart_frames[9].chart_window.isVisible() && logfiletype == 2)
            {   
                chart_frames[9].chart_window.setTitle("Knock");
                chart_frames[9].chart_window.chart_low = 0;
                chart_frames[9].chart_window.chart_high = 75;
            }
            if (!chart_frames[10].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[10].chart_window.setTitle("Air Flow (hz)");
                chart_frames[10].chart_window.chart_low = 0;
                chart_frames[10].chart_window.chart_high = 3000;
            }
            if (!chart_frames[11].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[11].chart_window.setTitle("O2v 2");
                chart_frames[11].chart_window.chart_low = 0;
                chart_frames[11].chart_window.chart_high = 150;
            }
            if (!chart_frames[12].chart_window.isVisible())
            {   
                chart_frames[12].chart_window.setTitle("Long Trim 1");
                if (logfiletype == 2)
                {
                    chart_frames[12].chart_window.setTitle("Long Trim 1");
                    chart_frames[12].chart_window.chart_low = 0;
                    chart_frames[12].chart_window.chart_high = 255;
                }
                else
                {
                    chart_frames[12].chart_window.setTitle("High Trim");
                    chart_frames[12].chart_window.chart_low = 128;
                    chart_frames[12].chart_window.chart_high = 128;
                }
            }
            if (!chart_frames[13].chart_window.isVisible())
            {   
                chart_frames[13].chart_window.setTitle("Short Trim 1");
                if (logfiletype == 2)
                {
                    chart_frames[13].chart_window.setTitle("Short Trim 1");
                    chart_frames[13].chart_window.chart_low = 0;
                    chart_frames[13].chart_window.chart_high = 255;
                }
                else
                {
                    chart_frames[13].chart_window.setTitle("Low Trim");
                    chart_frames[13].chart_window.chart_low = 128;
                    chart_frames[13].chart_window.chart_high = 128;
                }
            }
            if (!chart_frames[14].chart_window.isVisible())
            {   
                chart_frames[14].chart_window.setTitle("Long Trim 2");
                if (logfiletype == 2)
                {
                    chart_frames[14].chart_window.chart_low = 0;
                    chart_frames[14].chart_window.chart_high = 255;
                }
                else
                {
                    chart_frames[14].chart_window.chart_low = 128;
                    chart_frames[14].chart_window.chart_high = 128;
                }
            }
            if (!chart_frames[15].chart_window.isVisible())
            {   
                chart_frames[15].chart_window.setTitle("Short Trim 2");
                if (logfiletype == 2)
                {
                    chart_frames[15].chart_window.chart_low = 0;
                    chart_frames[15].chart_window.chart_high = 255;
                }
                else
                {
                    chart_frames[15].chart_window.chart_low = 128;
                    chart_frames[15].chart_window.chart_high = 128;
                }
            }
            if (!chart_frames[16].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[16].chart_window.setTitle("MPH");
                chart_frames[16].chart_window.chart_low = 0;
                chart_frames[16].chart_window.chart_high = 255;
            }
            if (!chart_frames[17].chart_window.isVisible() && logfiletype == 2)
            {   
                chart_frames[17].chart_window.setTitle("Medium Trim");
                chart_frames[17].chart_window.chart_low = 0;
                chart_frames[17].chart_window.chart_high = 255;
            }
            if (!chart_frames[18].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[18].chart_window.setTitle("Load");
                chart_frames[18].chart_window.chart_low = 0;
                chart_frames[18].chart_window.chart_high = 255;
            }
            if (!chart_frames[19].chart_window.isVisible() && logfiletype == 2)
            {   
                chart_frames[19].chart_window.setTitle("O2v Trim");
                chart_frames[19].chart_window.chart_low = 0;
                chart_frames[19].chart_window.chart_high = 255;
            }
            if (!chart_frames[20].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[20].chart_window.setTitle("ECU P/W");
                chart_frames[20].chart_window.chart_low = 0;
                chart_frames[20].chart_window.chart_high = 100;
            }
            if (!chart_frames[21].chart_window.isVisible() && logfiletype == 1)
            {   
                chart_frames[21].chart_window.setTitle("ECU Timing");
                chart_frames[21].chart_window.chart_low = 0;
                chart_frames[21].chart_window.chart_high = 64;
            }
            if (!chart_frames[22].chart_window.isVisible())
            {   
                chart_frames[22].chart_window.setTitle("Inj D/C");
                chart_frames[22].chart_window.chart_low = 0;
                chart_frames[22].chart_window.chart_high = 100;
            }
            if (logfiletype == 2)
            {
                chart_frames[1].chart_window.plot_point(drb_rpms * 100);
                chart_frames[2].chart_window.plot_point(drb_timing * 100);
                chart_frames[3].chart_window.plot_point((int)(drb_pulsewidth * 100F));
                chart_frames[4].chart_window.plot_point(drb_watertemp * 100);
                chart_frames[5].chart_window.plot_point((int)(drb_o2voltage * 10000F));
                chart_frames[6].chart_window.plot_point(drb_airtemp * 100);
                chart_frames[7].chart_window.plot_point(drb_tps * 100);
                chart_frames[8].chart_window.plot_point(drb_map * 100);
                chart_frames[9].chart_window.plot_point(drb_knock * 100);
                chart_frames[10].chart_window.plot_point((int)(drb_afhz * 10000));
                chart_frames[11].chart_window.plot_point((int)(drb_o2 * 10000F));
                chart_frames[12].chart_window.plot_point(drb_l1 * 100);
                chart_frames[13].chart_window.plot_point(drb_s1 * 100);
                chart_frames[14].chart_window.plot_point(drb_l2 * 100);
                chart_frames[15].chart_window.plot_point(drb_s2 * 100);
                chart_frames[16].chart_window.plot_point(drb_mph * 100);
                chart_frames[17].chart_window.plot_point(drb_mtrim * 100);
                chart_frames[18].chart_window.plot_point(drb_load * 100);
                chart_frames[19].chart_window.plot_point(drb_o2trim * 100);
                chart_frames[22].chart_window.plot_point(100 * (int)(trim_decimals((drb_pulsewidth * drb_rpms) / 1200F)));
            }
            else
                if (logfiletype == 1)
                {
                    chart_frames[2].chart_window.plot_point(pms_timing * 100);
                    chart_frames[1].chart_window.plot_point(pms_ecu_rpms * 100);
                    chart_frames[3].chart_window.plot_point((int)(pms_pulsewidth * 100F));
                    chart_frames[4].chart_window.plot_point(pms_watertemp * 100);
                    chart_frames[5].chart_window.plot_point((int)(pms_o2voltage * 10000F));
                    chart_frames[6].chart_window.plot_point(pms_airtemp * 100);
                    chart_frames[7].chart_window.plot_point(pms_tps * 100);
                    if (pms_pressure < 1F)
                      chart_frames[8].chart_window.plot_point(0);
                    else
                      chart_frames[8].chart_window.plot_point((int)(pms_pressure * 100));
                    chart_frames[10].chart_window.plot_point(pms_hz * 100);
                    chart_frames[20].chart_window.plot_point((int)(pms_ecu_pulsewidth * 100));
                    chart_frames[21].chart_window.plot_point(pms_ecu_timing * 100);
                    chart_frames[22].chart_window.plot_point(100 * (int)(trim_decimals((pms_pulsewidth * pms_ecu_rpms) / 1200F)));
                }
            for (loopa=1;loopa<=max_charts;loopa++)
            {
/*                if (logfiletype == 1 && loopa == 11)
                    continue;
                if (logfiletype == 2 && loopa == 8)
                    continue; */
                chart_frames[loopa].chart_window.pf = this;
                chart_frames[loopa].chart_window.chartcontrol_frame = chartcontrol_frame;
                chart_frames[loopa].chart_window.last_record = current_log_record;
                chart_frames[loopa].chart_window.curr_record = current_log_record;
                chart_frames[loopa].chart_window.log_records = log_records;
            }
            single_click = false;
	    }
	    while (current_log_record < log_records);
	    for (loopa=1;loopa<=max_charts;loopa++)
	    {
/*            if (logfiletype == 1 && loopa == 11)
               continue;
            if (logfiletype == 2 && loopa == 8)
               continue; */
            if (chart_frames[loopa] == null)
                continue;
	        chart_frames[loopa].chart_window.chart_loaded = true;
            if (chartcontrol_frame.button_flag[loopa].getBackground() == java.awt.Color.red)
                continue;
            chart_frames[loopa].chart_window.setVisible(true);
	        chart_frames[loopa].chart_window.paint();
	        chart_frames[loopa].chart_window.update_status();
        }
        rewindButton_mouseClicked(null);
        if (reg_flag == 1)
          chartcontrol_frame.setVisible(true);
        else
          chartcontrol_frame.setVisible(false);
        setTitle(ot);
        toggle_controls();
    }
    

	class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == tpsrange)
				tpsrange_actionPerformed(event);
		}
	}

	void tpsrange_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
        int y = tpsrange_value;
		try
        {
		    Integer x = new Integer(tpsrange.getText());
		    y = x.intValue();
//		    System.out.println(tpsrange_value + " " + x);
		}
		catch (NumberFormatException nfe)
		{
		    error_rtn("Must be numeric 0 to 100!");
		    tpsrange.setText(Integer.toString(95));
		    y = 95;
		}
		if (y < 0 || y > 100)
		{
		    error_rtn("Must be numeric 0 to 100!");
		    tpsrange.setText(Integer.toString(95));
		    y = 95;
		} 
		tpsrange_value = y;
	
	}

	class SymKey extends java.awt.event.KeyAdapter
	{
		public void keyTyped(java.awt.event.KeyEvent event)
		{
			Object object = event.getSource();
			if (object == tpsrange)
				tpsrange_keyTyped(event);
		}
	}

	void tpsrange_keyTyped(java.awt.event.KeyEvent event)
	{
		// to do: code goes here.
	}
	
	void reset_charts()
	{
	    int loop;
	    
        if (chartcontrol_frame == null)
        {
            chartcontrol_frame = new chartcontrolp();
            chartcontrol_frame.pf = this;
            if (reg_flag == 1)
              chartcontrol_frame.setVisible(true);
            else
              chartcontrol_frame.setVisible(false);
        }
	    for (loop=1;loop<=max_charts;loop++)
	        if (chart_frames[loop] != null)
	        {
		        do
		        {
		        }
		        while (chart_frames[loop].chart_window == null);
	            chart_frames[loop].chart_window.setVisible(false);
                chart_frames[loop].chart_window.clear_chart();
	        }
		    
		if (logfiletype == 1)
		{
		    chartcontrol_frame.pwbutton.setEnabled(true);
		    chartcontrol_frame.o2vbutton.setEnabled(true);
		    chartcontrol_frame.tpsbutton.setEnabled(true);
		    chartcontrol_frame.boostbutton.setEnabled(true);
		    chartcontrol_frame.rpmbutton.setEnabled(true);
		    chartcontrol_frame.timingbutton.setEnabled(true);
		    chartcontrol_frame.knockbutton.setEnabled(false);
            chartcontrol_frame.afhzbtton.setEnabled(true);
            chartcontrol_frame.waterbutton.setEnabled(true);
            chartcontrol_frame.airbutton.setEnabled(true);
            chartcontrol_frame.o2v2button.setEnabled(false);
            chartcontrol_frame.ltrim1button.setEnabled(false);
            chartcontrol_frame.strim1button.setEnabled(false);
            chartcontrol_frame.ltrim2button.setEnabled(false);
            chartcontrol_frame.strim2button.setEnabled(false);
            chartcontrol_frame.mphbutton.setEnabled(false);
            chartcontrol_frame.mtrimbutton.setEnabled(false);
            chartcontrol_frame.loadbutton.setEnabled(false);
            chartcontrol_frame.o2trimbutton.setEnabled(false);
            chartcontrol_frame.ecupwbutton.setEnabled(true);
            chartcontrol_frame.ecutimingbutton.setEnabled(true);
            chartcontrol_frame.injdcbutton.setEnabled(true);
		}
		if (logfiletype == 2)
		{
            chartcontrol_frame.ecupwbutton.setEnabled(false);
            chartcontrol_frame.ecutimingbutton.setEnabled(false);
            chartcontrol_frame.injdcbutton.setEnabled(false);
            chartcontrol_frame.timingbutton.setEnabled(false);
            chartcontrol_frame.o2vbutton.setEnabled(false);
            chartcontrol_frame.tpsbutton.setEnabled(false);
            chartcontrol_frame.rpmbutton.setEnabled(false);
            chartcontrol_frame.pwbutton.setEnabled(false);
            chartcontrol_frame.knockbutton.setEnabled(false);
            chartcontrol_frame.boostbutton.setEnabled(false);
            chartcontrol_frame.afhzbtton.setEnabled(false);
            chartcontrol_frame.waterbutton.setEnabled(false);
            chartcontrol_frame.airbutton.setEnabled(false);
            chartcontrol_frame.o2v2button.setEnabled(false);
            chartcontrol_frame.ltrim1button.setEnabled(false);
            chartcontrol_frame.strim1button.setEnabled(false);
            chartcontrol_frame.ltrim2button.setEnabled(false);
            chartcontrol_frame.strim2button.setEnabled(false);
            chartcontrol_frame.mphbutton.setEnabled(false);
            chartcontrol_frame.mtrimbutton.setEnabled(false);
            chartcontrol_frame.loadbutton.setEnabled(false);
		    for (loop=0;loop<=drb_parm_count;loop++)
		    {
		        if (drb_type[loop] == 1)
		            chartcontrol_frame.timingbutton.setEnabled(true);
		        if (drb_type[loop] == 4)
		            chartcontrol_frame.o2vbutton.setEnabled(true);
		        if (drb_type[loop] == 8)
		            chartcontrol_frame.tpsbutton.setEnabled(true);
		        if (drb_type[loop] == 10)
		            chartcontrol_frame.rpmbutton.setEnabled(true);
		        if (drb_type[loop] == 11)
		            chartcontrol_frame.pwbutton.setEnabled(true);
		        if (drb_type[loop] == 18)
		            chartcontrol_frame.knockbutton.setEnabled(true);
		        if (drb_type[loop] == 91)
		            chartcontrol_frame.mphbutton.setEnabled(true);
		        if (drb_type[loop] == 92)
		            chartcontrol_frame.boostbutton.setEnabled(true);
		        if (drb_type[loop] == 13)
		            chartcontrol_frame.strim1button.setEnabled(true);
		        if (drb_type[loop] == 93)
		            chartcontrol_frame.strim2button.setEnabled(true);
		        if (drb_type[loop] == 14)
		            chartcontrol_frame.ltrim1button.setEnabled(true);
		        if (drb_type[loop] == 94)
		            chartcontrol_frame.ltrim2button.setEnabled(true);
		        if (drb_type[loop] == 95)
		            chartcontrol_frame.loadbutton.setEnabled(true);
		        if (drb_type[loop] == 96)
		            chartcontrol_frame.o2v2button.setEnabled(true);
		        if (drb_type[loop] == 15)
		            chartcontrol_frame.o2trimbutton.setEnabled(true);
		        if (drb_type[loop] == 19)
		            chartcontrol_frame.afhzbtton.setEnabled(true);
		        if (drb_type[loop] == 2)
		            chartcontrol_frame.waterbutton.setEnabled(true);
		        if (drb_type[loop] == 12)
		            chartcontrol_frame.airbutton.setEnabled(true);
		    }
		}
	}

	void pnsteinbutton_mouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
			 
		pnsteinbutton_mouseClicked_Interaction1(event);
	}

	void pnsteinbutton_mouseClicked_Interaction1(java.awt.event.MouseEvent event)
	{
		try 
		{
			// PNSTEINdialog Create and show as modal
			{
			    if (PNSTEINdialog1 == null)
        			PNSTEINdialog1 = new PNSTEINdialog();
				PNSTEINdialog1.pf = this;
		        PNSTEINdialog1.start_log.setVisible(true);
		        PNSTEINdialog1.cancel_button.setVisible(true);
		        PNSTEINdialog1.port_list.setVisible(true);
				PNSTEINdialog1.setModal(false);
				PNSTEINdialog1.show();
			}
		} 
		catch (java.lang.Exception e) 
		{
		} 
	    
	}
	
    void dump_log_record()
    {
		int   temp_int;
		int   ub1 = 0;
		
		rtd_line = "";
		for (temp_int=0;temp_int<64;temp_int++)
		{
		  try
		  {
		  ub1 = (int)rf1.readByte();
		  }
		  catch (IOException ioe)
		  {
		  }
		  if (ub1 < 0)
            rtd_line = rtd_line + Integer.toString((128 + (ub1 * -1))) + " ";
		  else
            rtd_line = rtd_line + Integer.toString(ub1) + " ";
        }
//        System.out.println(rtd_line);
    }
    

	void DataDisplay_MouseClicked(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
	}

	void tpsrange_focusLost(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.
			 
        int y = tpsrange_value;
		try
        {
		    Integer x = new Integer(tpsrange.getText());
		    y = x.intValue();
		    //System.out.println(y + " " + tpsrange_value);
		}
		catch (NumberFormatException nfe)
		{
		    error_rtn("Must be numeric 0 to 100!");
		    tpsrange.setText(Integer.toString(95));
		    y = 95;
		}
		if (y < 0 || y > 100)
		{
		    error_rtn("Must be numeric 0 to 100!");
		    tpsrange.setText(Integer.toString(95));
		    y = 95;
		} 
		tpsrange_value = y;
	}

	void rpmrange_focusLost(java.awt.event.FocusEvent event)
	{
		// to do: code goes here.
			 
        int y = rpmrange_value;
		try
        {
		    Integer x = new Integer(rpmrange.getText());
		    y = x.intValue();
//		    System.out.println(tpsrange_value + " " + x);
		}
		catch (NumberFormatException nfe)
		{
		    error_rtn("Must be numeric 0 to 8000!");
		    rpmrange.setText(Integer.toString(4000));
		    y = 4000;
		}
		if (y < 0 || y > 8000)
		{
		    error_rtn("Must be numeric 0 to 8000!");
		    tpsrange.setText(Integer.toString(4000));
		    y = 4000;
		} 
		rpmrange_value = y;
	
	}
}

